-- MySQL dump 10.13  Distrib 22.10.11LTS, for Linux (x86_64)
--
-- Host: localhost    Database: ycsb
-- ------------------------------------------------------
-- Server version	22.10.11LTS-cluster

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Current Database: `ycsb`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `ycsb` /*!40100 DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci */ /*!80016 DEFAULT ENCRYPTION='N' */;

USE `ycsb`;

--
-- Table structure for table `usertable`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `usertable` (
  `YCSB_KEY` varchar(255) COLLATE utf8mb4_unicode_ci NOT NULL,
  `FIELD0` varbinary(4096) DEFAULT NULL,
  PRIMARY KEY (`YCSB_KEY`)
) ENGINE=ndbcluster DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping events for database 'ycsb'
--

--
-- Dumping routines for database 'ycsb'
--

--
-- Current Database: `heartbeat`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `heartbeat` /*!40100 DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci */ /*!80016 DEFAULT ENCRYPTION='N' */;

USE `heartbeat`;

--
-- Table structure for table `heartbeat`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `heartbeat` (
  `server_id` int NOT NULL,
  `counter` bigint unsigned NOT NULL,
  `updated_at` timestamp NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`server_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping events for database 'heartbeat'
--

--
-- Dumping routines for database 'heartbeat'
--

--
-- Current Database: `metastore`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `metastore` /*!40100 DEFAULT CHARACTER SET latin1 */ /*!80016 DEFAULT ENCRYPTION='N' */;

USE `metastore`;

--
-- Table structure for table `AUX_TABLE`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `AUX_TABLE` (
  `MT_KEY1` varchar(128) NOT NULL,
  `MT_KEY2` bigint NOT NULL,
  `MT_COMMENT` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`MT_KEY1`,`MT_KEY2`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `BUCKETING_COLS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `BUCKETING_COLS` (
  `SD_ID` bigint NOT NULL,
  `BUCKET_COL_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `INTEGER_IDX` int NOT NULL,
  PRIMARY KEY (`SD_ID`,`INTEGER_IDX`),
  KEY `BUCKETING_COLS_N49` (`SD_ID`),
  CONSTRAINT `BUCKETING_COLS_FK1` FOREIGN KEY (`SD_ID`) REFERENCES `SDS` (`SD_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `CDS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `CDS` (
  `CD_ID` bigint NOT NULL,
  PRIMARY KEY (`CD_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `COLUMNS_V2`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `COLUMNS_V2` (
  `CD_ID` bigint NOT NULL,
  `COMMENT` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `COLUMN_NAME` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `TYPE_NAME` mediumtext,
  `INTEGER_IDX` int NOT NULL,
  PRIMARY KEY (`CD_ID`,`COLUMN_NAME`),
  KEY `COLUMNS_V2_N49` (`CD_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `COMPACTION_QUEUE`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `COMPACTION_QUEUE` (
  `CQ_ID` bigint NOT NULL,
  `CQ_DATABASE` varchar(128) NOT NULL,
  `CQ_TABLE` varchar(128) NOT NULL,
  `CQ_PARTITION` varchar(767) DEFAULT NULL,
  `CQ_STATE` char(1) NOT NULL,
  `CQ_TYPE` char(1) NOT NULL,
  `CQ_TBLPROPERTIES` varchar(2048) DEFAULT NULL,
  `CQ_WORKER_ID` varchar(128) DEFAULT NULL,
  `CQ_START` bigint DEFAULT NULL,
  `CQ_RUN_AS` varchar(128) DEFAULT NULL,
  `CQ_HIGHEST_WRITE_ID` bigint DEFAULT NULL,
  `CQ_META_INFO` varbinary(2048) DEFAULT NULL,
  `CQ_HADOOP_JOB_ID` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`CQ_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `COMPLETED_COMPACTIONS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `COMPLETED_COMPACTIONS` (
  `CC_ID` bigint NOT NULL,
  `CC_DATABASE` varchar(128) NOT NULL,
  `CC_TABLE` varchar(128) NOT NULL,
  `CC_PARTITION` varchar(767) DEFAULT NULL,
  `CC_STATE` char(1) NOT NULL,
  `CC_TYPE` char(1) NOT NULL,
  `CC_TBLPROPERTIES` varchar(2048) DEFAULT NULL,
  `CC_WORKER_ID` varchar(128) DEFAULT NULL,
  `CC_START` bigint DEFAULT NULL,
  `CC_END` bigint DEFAULT NULL,
  `CC_RUN_AS` varchar(128) DEFAULT NULL,
  `CC_HIGHEST_WRITE_ID` bigint DEFAULT NULL,
  `CC_META_INFO` varbinary(2048) DEFAULT NULL,
  `CC_HADOOP_JOB_ID` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`CC_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `COMPLETED_TXN_COMPONENTS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `COMPLETED_TXN_COMPONENTS` (
  `CTC_TXNID` bigint NOT NULL,
  `CTC_DATABASE` varchar(128) NOT NULL,
  `CTC_TABLE` varchar(256) DEFAULT NULL,
  `CTC_PARTITION` varchar(767) DEFAULT NULL,
  `CTC_TIMESTAMP` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `CTC_WRITEID` bigint DEFAULT NULL,
  KEY `COMPLETED_TXN_COMPONENTS_IDX` (`CTC_DATABASE`,`CTC_TABLE`,`CTC_PARTITION`) USING BTREE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `CTLGS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `CTLGS` (
  `CTLG_ID` bigint NOT NULL,
  `NAME` varchar(256) COLLATE latin1_general_cs DEFAULT NULL,
  `DESC` varchar(4000) COLLATE latin1_general_cs DEFAULT NULL,
  `SD_ID` bigint DEFAULT NULL,
  PRIMARY KEY (`CTLG_ID`),
  UNIQUE KEY `UNIQUE_CATALOG` (`NAME`),
  KEY `CTLGS_SD_FK` (`SD_ID`),
  CONSTRAINT `CTLGS_SD_FK` FOREIGN KEY (`SD_ID`) REFERENCES `SDS` (`SD_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `DATABASE_PARAMS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `DATABASE_PARAMS` (
  `DB_ID` bigint NOT NULL,
  `PARAM_KEY` varchar(180) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `PARAM_VALUE` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`DB_ID`,`PARAM_KEY`),
  KEY `DATABASE_PARAMS_N49` (`DB_ID`),
  CONSTRAINT `DATABASE_PARAMS_FK1` FOREIGN KEY (`DB_ID`) REFERENCES `DBS` (`DB_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `DBS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `DBS` (
  `DB_ID` bigint NOT NULL,
  `DESC` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `OWNER_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `OWNER_TYPE` varchar(10) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `SD_ID` bigint DEFAULT NULL,
  `CTLG_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`DB_ID`),
  UNIQUE KEY `UNIQUE_DATABASE` (`NAME`,`CTLG_NAME`),
  KEY `CTLG_FK1` (`CTLG_NAME`),
  KEY `DB_SD_FK` (`SD_ID`),
  CONSTRAINT `CTLG_FK1` FOREIGN KEY (`CTLG_NAME`) REFERENCES `CTLGS` (`NAME`) ON DELETE CASCADE ON UPDATE RESTRICT,
  CONSTRAINT `DB_SD_FK` FOREIGN KEY (`SD_ID`) REFERENCES `SDS` (`SD_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `DB_PRIVS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `DB_PRIVS` (
  `DB_GRANT_ID` bigint NOT NULL,
  `CREATE_TIME` int NOT NULL,
  `DB_ID` bigint DEFAULT NULL,
  `GRANT_OPTION` smallint NOT NULL,
  `GRANTOR` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `GRANTOR_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `DB_PRIV` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`DB_GRANT_ID`),
  UNIQUE KEY `DBPRIVILEGEINDEX` (`DB_ID`,`PRINCIPAL_NAME`,`PRINCIPAL_TYPE`,`DB_PRIV`,`GRANTOR`,`GRANTOR_TYPE`),
  KEY `DB_PRIVS_N49` (`DB_ID`),
  CONSTRAINT `DB_PRIVS_FK1` FOREIGN KEY (`DB_ID`) REFERENCES `DBS` (`DB_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `FUNCS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `FUNCS` (
  `FUNC_ID` bigint NOT NULL,
  `CLASS_NAME` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `CREATE_TIME` int NOT NULL,
  `DB_ID` bigint DEFAULT NULL,
  `FUNC_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `FUNC_TYPE` int NOT NULL,
  `OWNER_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `OWNER_TYPE` varchar(10) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`FUNC_ID`),
  UNIQUE KEY `UNIQUEFUNCTION` (`FUNC_NAME`,`DB_ID`),
  KEY `FUNCS_N49` (`DB_ID`),
  CONSTRAINT `FUNCS_FK1` FOREIGN KEY (`DB_ID`) REFERENCES `DBS` (`DB_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `FUNC_RU`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `FUNC_RU` (
  `FUNC_ID` bigint NOT NULL,
  `RESOURCE_TYPE` int NOT NULL,
  `RESOURCE_URI` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `INTEGER_IDX` int NOT NULL,
  PRIMARY KEY (`FUNC_ID`,`INTEGER_IDX`),
  CONSTRAINT `FUNC_RU_FK1` FOREIGN KEY (`FUNC_ID`) REFERENCES `FUNCS` (`FUNC_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `GLOBAL_PRIVS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `GLOBAL_PRIVS` (
  `USER_GRANT_ID` bigint NOT NULL,
  `CREATE_TIME` int NOT NULL,
  `GRANT_OPTION` smallint NOT NULL,
  `GRANTOR` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `GRANTOR_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `USER_PRIV` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`USER_GRANT_ID`),
  UNIQUE KEY `GLOBALPRIVILEGEINDEX` (`PRINCIPAL_NAME`,`PRINCIPAL_TYPE`,`USER_PRIV`,`GRANTOR`,`GRANTOR_TYPE`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `HIVE_LOCKS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `HIVE_LOCKS` (
  `HL_LOCK_EXT_ID` bigint NOT NULL,
  `HL_LOCK_INT_ID` bigint NOT NULL,
  `HL_TXNID` bigint NOT NULL,
  `HL_DB` varchar(128) NOT NULL,
  `HL_TABLE` varchar(128) DEFAULT NULL,
  `HL_PARTITION` varchar(767) DEFAULT NULL,
  `HL_LOCK_STATE` char(1) NOT NULL,
  `HL_LOCK_TYPE` char(1) NOT NULL,
  `HL_LAST_HEARTBEAT` bigint NOT NULL,
  `HL_ACQUIRED_AT` bigint DEFAULT NULL,
  `HL_USER` varchar(128) NOT NULL,
  `HL_HOST` varchar(128) NOT NULL,
  `HL_HEARTBEAT_COUNT` int DEFAULT NULL,
  `HL_AGENT_INFO` varchar(128) DEFAULT NULL,
  `HL_BLOCKEDBY_EXT_ID` bigint DEFAULT NULL,
  `HL_BLOCKEDBY_INT_ID` bigint DEFAULT NULL,
  PRIMARY KEY (`HL_LOCK_EXT_ID`,`HL_LOCK_INT_ID`),
  KEY `HIVE_LOCK_TXNID_INDEX` (`HL_TXNID`),
  KEY `HL_TXNID_IDX` (`HL_TXNID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `IDXS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `IDXS` (
  `INDEX_ID` bigint NOT NULL,
  `CREATE_TIME` int NOT NULL,
  `DEFERRED_REBUILD` bit(1) NOT NULL,
  `INDEX_HANDLER_CLASS` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `INDEX_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `INDEX_TBL_ID` bigint DEFAULT NULL,
  `LAST_ACCESS_TIME` int NOT NULL,
  `ORIG_TBL_ID` bigint DEFAULT NULL,
  `SD_ID` bigint DEFAULT NULL,
  PRIMARY KEY (`INDEX_ID`),
  UNIQUE KEY `UNIQUEINDEX` (`INDEX_NAME`,`ORIG_TBL_ID`),
  KEY `IDXS_N51` (`SD_ID`),
  KEY `IDXS_N50` (`INDEX_TBL_ID`),
  KEY `IDXS_N49` (`ORIG_TBL_ID`),
  CONSTRAINT `IDXS_FK1` FOREIGN KEY (`ORIG_TBL_ID`) REFERENCES `TBLS` (`TBL_ID`) ON DELETE CASCADE ON UPDATE RESTRICT,
  CONSTRAINT `IDXS_FK2` FOREIGN KEY (`SD_ID`) REFERENCES `SDS` (`SD_ID`) ON DELETE CASCADE ON UPDATE RESTRICT,
  CONSTRAINT `IDXS_FK3` FOREIGN KEY (`INDEX_TBL_ID`) REFERENCES `TBLS` (`TBL_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `INDEX_PARAMS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `INDEX_PARAMS` (
  `INDEX_ID` bigint NOT NULL,
  `PARAM_KEY` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `PARAM_VALUE` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`INDEX_ID`,`PARAM_KEY`),
  KEY `INDEX_PARAMS_N49` (`INDEX_ID`),
  CONSTRAINT `INDEX_PARAMS_FK1` FOREIGN KEY (`INDEX_ID`) REFERENCES `IDXS` (`INDEX_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `I_SCHEMA`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `I_SCHEMA` (
  `SCHEMA_ID` bigint NOT NULL,
  `SCHEMA_TYPE` int NOT NULL,
  `NAME` varchar(256) DEFAULT NULL,
  `DB_ID` bigint DEFAULT NULL,
  `COMPATIBILITY` int NOT NULL,
  `VALIDATION_LEVEL` int NOT NULL,
  `CAN_EVOLVE` bit(1) NOT NULL,
  `SCHEMA_GROUP` varchar(256) DEFAULT NULL,
  `DESCRIPTION` varchar(4000) DEFAULT NULL,
  PRIMARY KEY (`SCHEMA_ID`),
  KEY `DB_ID` (`DB_ID`),
  KEY `UNIQUE_NAME` (`NAME`),
  CONSTRAINT `I_SCHEMA_fk_1` FOREIGN KEY (`DB_ID`) REFERENCES `DBS` (`DB_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `KEY_CONSTRAINTS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `KEY_CONSTRAINTS` (
  `CHILD_CD_ID` bigint DEFAULT NULL,
  `CHILD_INTEGER_IDX` int DEFAULT NULL,
  `CHILD_TBL_ID` bigint DEFAULT NULL,
  `PARENT_CD_ID` bigint DEFAULT NULL,
  `PARENT_INTEGER_IDX` int NOT NULL,
  `PARENT_TBL_ID` bigint NOT NULL,
  `POSITION` bigint NOT NULL,
  `CONSTRAINT_NAME` varchar(400) NOT NULL,
  `CONSTRAINT_TYPE` smallint NOT NULL,
  `UPDATE_RULE` smallint DEFAULT NULL,
  `DELETE_RULE` smallint DEFAULT NULL,
  `ENABLE_VALIDATE_RELY` smallint NOT NULL,
  `DEFAULT_VALUE` varchar(400) DEFAULT NULL,
  PRIMARY KEY (`CONSTRAINT_NAME`,`POSITION`),
  KEY `KEY_CONSTRAINTS_FK1` (`CHILD_CD_ID`),
  KEY `KEY_CONSTRAINTS_FK3` (`PARENT_CD_ID`),
  KEY `KEY_CONSTRAINTS_FK2` (`CHILD_TBL_ID`),
  KEY `CONSTRAINTS_PARENT_TABLE_ID_INDEX` (`PARENT_TBL_ID`) USING BTREE,
  KEY `CONSTRAINTS_CONSTRAINT_TYPE_INDEX` (`CONSTRAINT_TYPE`) USING BTREE,
  CONSTRAINT `KEY_CONSTRAINTS_FK1` FOREIGN KEY (`CHILD_CD_ID`) REFERENCES `CDS` (`CD_ID`) ON DELETE CASCADE,
  CONSTRAINT `KEY_CONSTRAINTS_FK2` FOREIGN KEY (`CHILD_TBL_ID`) REFERENCES `TBLS` (`TBL_ID`) ON DELETE CASCADE,
  CONSTRAINT `KEY_CONSTRAINTS_FK3` FOREIGN KEY (`PARENT_CD_ID`) REFERENCES `CDS` (`CD_ID`) ON DELETE CASCADE,
  CONSTRAINT `KEY_CONSTRAINTS_FK4` FOREIGN KEY (`PARENT_TBL_ID`) REFERENCES `TBLS` (`TBL_ID`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `METASTORE_DB_PROPERTIES`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `METASTORE_DB_PROPERTIES` (
  `PROPERTY_KEY` varchar(255) NOT NULL,
  `PROPERTY_VALUE` varchar(1000) NOT NULL,
  `DESCRIPTION` varchar(1000) DEFAULT NULL,
  PRIMARY KEY (`PROPERTY_KEY`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `MIN_HISTORY_LEVEL`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `MIN_HISTORY_LEVEL` (
  `MHL_TXNID` bigint NOT NULL,
  `MHL_MIN_OPEN_TXNID` bigint NOT NULL,
  PRIMARY KEY (`MHL_TXNID`),
  KEY `MIN_HISTORY_LEVEL_IDX` (`MHL_MIN_OPEN_TXNID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `MV_CREATION_METADATA`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `MV_CREATION_METADATA` (
  `MV_CREATION_METADATA_ID` bigint NOT NULL,
  `CAT_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `DB_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `TBL_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `TXN_LIST` text,
  PRIMARY KEY (`MV_CREATION_METADATA_ID`),
  KEY `MV_UNIQUE_TABLE` (`TBL_NAME`,`DB_NAME`) USING BTREE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `MV_TABLES_USED`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `MV_TABLES_USED` (
  `MV_CREATION_METADATA_ID` bigint NOT NULL,
  `TBL_ID` bigint NOT NULL,
  KEY `MV_TABLES_USED_FK1` (`MV_CREATION_METADATA_ID`),
  KEY `MV_TABLES_USED_FK2` (`TBL_ID`),
  CONSTRAINT `MV_TABLES_USED_FK1` FOREIGN KEY (`MV_CREATION_METADATA_ID`) REFERENCES `MV_CREATION_METADATA` (`MV_CREATION_METADATA_ID`),
  CONSTRAINT `MV_TABLES_USED_FK2` FOREIGN KEY (`TBL_ID`) REFERENCES `TBLS` (`TBL_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `NEXT_COMPACTION_QUEUE_ID`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `NEXT_COMPACTION_QUEUE_ID` (
  `NCQ_NEXT` bigint NOT NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `NEXT_LOCK_ID`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `NEXT_LOCK_ID` (
  `NL_NEXT` bigint NOT NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `NEXT_TXN_ID`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `NEXT_TXN_ID` (
  `NTXN_NEXT` bigint NOT NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `NEXT_WRITE_ID`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `NEXT_WRITE_ID` (
  `NWI_DATABASE` varchar(128) NOT NULL,
  `NWI_TABLE` varchar(256) NOT NULL,
  `NWI_NEXT` bigint NOT NULL,
  UNIQUE KEY `NEXT_WRITE_ID_IDX` (`NWI_DATABASE`,`NWI_TABLE`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `NOTIFICATION_LOG`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `NOTIFICATION_LOG` (
  `NL_ID` bigint NOT NULL,
  `EVENT_ID` bigint NOT NULL,
  `EVENT_TIME` int NOT NULL,
  `EVENT_TYPE` varchar(32) NOT NULL,
  `CAT_NAME` varchar(256) DEFAULT NULL,
  `DB_NAME` varchar(128) DEFAULT NULL,
  `TBL_NAME` varchar(256) DEFAULT NULL,
  `MESSAGE` longtext,
  `MESSAGE_FORMAT` varchar(16) DEFAULT NULL,
  PRIMARY KEY (`NL_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `NOTIFICATION_SEQUENCE`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `NOTIFICATION_SEQUENCE` (
  `NNI_ID` bigint NOT NULL,
  `NEXT_EVENT_ID` bigint NOT NULL,
  PRIMARY KEY (`NNI_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `NUCLEUS_TABLES`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `NUCLEUS_TABLES` (
  `CLASS_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `TABLE_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `TYPE` varchar(4) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `OWNER` varchar(2) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `VERSION` varchar(20) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `INTERFACE_NAME` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`CLASS_NAME`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `PARTITIONS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `PARTITIONS` (
  `PART_ID` bigint NOT NULL,
  `CREATE_TIME` int NOT NULL,
  `LAST_ACCESS_TIME` int NOT NULL,
  `PART_NAME` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `SD_ID` bigint DEFAULT NULL,
  `TBL_ID` bigint DEFAULT NULL,
  PRIMARY KEY (`PART_ID`),
  UNIQUE KEY `UNIQUEPARTITION` (`PART_NAME`,`TBL_ID`),
  KEY `PARTITIONS_N49` (`TBL_ID`),
  KEY `PARTITIONS_N50` (`SD_ID`),
  CONSTRAINT `PARTITIONS_FK1` FOREIGN KEY (`TBL_ID`) REFERENCES `TBLS` (`TBL_ID`) ON DELETE CASCADE ON UPDATE RESTRICT,
  CONSTRAINT `PARTITIONS_FK2` FOREIGN KEY (`SD_ID`) REFERENCES `SDS` (`SD_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `PARTITION_EVENTS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `PARTITION_EVENTS` (
  `PART_NAME_ID` bigint NOT NULL,
  `CAT_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `DB_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `EVENT_TIME` bigint NOT NULL,
  `EVENT_TYPE` int NOT NULL,
  `PARTITION_NAME` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `TBL_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`PART_NAME_ID`),
  KEY `PARTITIONEVENTINDEX` (`PARTITION_NAME`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `PARTITION_KEYS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `PARTITION_KEYS` (
  `TBL_ID` bigint NOT NULL,
  `PKEY_COMMENT` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PKEY_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `PKEY_TYPE` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `INTEGER_IDX` int NOT NULL,
  PRIMARY KEY (`TBL_ID`,`PKEY_NAME`),
  KEY `PARTITION_KEYS_N49` (`TBL_ID`),
  CONSTRAINT `PARTITION_KEYS_FK1` FOREIGN KEY (`TBL_ID`) REFERENCES `TBLS` (`TBL_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `PARTITION_KEY_VALS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `PARTITION_KEY_VALS` (
  `PART_ID` bigint NOT NULL,
  `PART_KEY_VAL` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `INTEGER_IDX` int NOT NULL,
  PRIMARY KEY (`PART_ID`,`INTEGER_IDX`),
  KEY `PARTITION_KEY_VALS_N49` (`PART_ID`),
  CONSTRAINT `PARTITION_KEY_VALS_FK1` FOREIGN KEY (`PART_ID`) REFERENCES `PARTITIONS` (`PART_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `PARTITION_PARAMS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `PARTITION_PARAMS` (
  `PART_ID` bigint NOT NULL,
  `PARAM_KEY` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `PARAM_VALUE` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`PART_ID`,`PARAM_KEY`),
  KEY `PARTITION_PARAMS_N49` (`PART_ID`),
  CONSTRAINT `PARTITION_PARAMS_FK1` FOREIGN KEY (`PART_ID`) REFERENCES `PARTITIONS` (`PART_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `PART_COL_PRIVS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `PART_COL_PRIVS` (
  `PART_COLUMN_GRANT_ID` bigint NOT NULL,
  `COLUMN_NAME` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `CREATE_TIME` int NOT NULL,
  `GRANT_OPTION` smallint NOT NULL,
  `GRANTOR` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `GRANTOR_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PART_ID` bigint DEFAULT NULL,
  `PRINCIPAL_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PART_COL_PRIV` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`PART_COLUMN_GRANT_ID`),
  KEY `PART_COL_PRIVS_N49` (`PART_ID`),
  KEY `PARTITIONCOLUMNPRIVILEGEINDEX` (`PART_ID`,`COLUMN_NAME`,`PRINCIPAL_NAME`,`PRINCIPAL_TYPE`,`PART_COL_PRIV`,`GRANTOR`,`GRANTOR_TYPE`),
  CONSTRAINT `PART_COL_PRIVS_FK1` FOREIGN KEY (`PART_ID`) REFERENCES `PARTITIONS` (`PART_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `PART_COL_STATS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `PART_COL_STATS` (
  `CS_ID` bigint NOT NULL,
  `CAT_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `DB_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `TABLE_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `PARTITION_NAME` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `COLUMN_NAME` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `COLUMN_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `PART_ID` bigint NOT NULL,
  `LONG_LOW_VALUE` bigint DEFAULT NULL,
  `LONG_HIGH_VALUE` bigint DEFAULT NULL,
  `DOUBLE_HIGH_VALUE` double(53,4) DEFAULT NULL,
  `DOUBLE_LOW_VALUE` double(53,4) DEFAULT NULL,
  `BIG_DECIMAL_LOW_VALUE` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `BIG_DECIMAL_HIGH_VALUE` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `NUM_NULLS` bigint NOT NULL,
  `NUM_DISTINCTS` bigint DEFAULT NULL,
  `BIT_VECTOR` blob,
  `AVG_COL_LEN` double(53,4) DEFAULT NULL,
  `MAX_COL_LEN` bigint DEFAULT NULL,
  `NUM_TRUES` bigint DEFAULT NULL,
  `NUM_FALSES` bigint DEFAULT NULL,
  `LAST_ANALYZED` bigint NOT NULL,
  PRIMARY KEY (`CS_ID`),
  KEY `PartIndex` (`PART_ID`),
  KEY `PCS_STATS_IDX` (`CAT_NAME`,`DB_NAME`,`TABLE_NAME`,`COLUMN_NAME`,`PARTITION_NAME`) USING BTREE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `PART_PRIVS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `PART_PRIVS` (
  `PART_GRANT_ID` bigint NOT NULL,
  `CREATE_TIME` int NOT NULL,
  `GRANT_OPTION` smallint NOT NULL,
  `GRANTOR` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `GRANTOR_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PART_ID` bigint DEFAULT NULL,
  `PRINCIPAL_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PART_PRIV` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`PART_GRANT_ID`),
  KEY `PARTPRIVILEGEINDEX` (`PART_ID`,`PRINCIPAL_NAME`,`PRINCIPAL_TYPE`,`PART_PRIV`,`GRANTOR`,`GRANTOR_TYPE`),
  KEY `PART_PRIVS_N49` (`PART_ID`),
  CONSTRAINT `PART_PRIVS_FK1` FOREIGN KEY (`PART_ID`) REFERENCES `PARTITIONS` (`PART_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `REPL_TXN_MAP`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `REPL_TXN_MAP` (
  `RTM_REPL_POLICY` varchar(256) NOT NULL,
  `RTM_SRC_TXN_ID` bigint NOT NULL,
  `RTM_TARGET_TXN_ID` bigint NOT NULL,
  PRIMARY KEY (`RTM_REPL_POLICY`,`RTM_SRC_TXN_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `ROLES`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `ROLES` (
  `ROLE_ID` bigint NOT NULL,
  `CREATE_TIME` int NOT NULL,
  `OWNER_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `ROLE_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`ROLE_ID`),
  UNIQUE KEY `ROLEENTITYINDEX` (`ROLE_NAME`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `ROLE_MAP`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `ROLE_MAP` (
  `ROLE_GRANT_ID` bigint NOT NULL,
  `ADD_TIME` int NOT NULL,
  `GRANT_OPTION` smallint NOT NULL,
  `GRANTOR` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `GRANTOR_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `ROLE_ID` bigint DEFAULT NULL,
  PRIMARY KEY (`ROLE_GRANT_ID`),
  UNIQUE KEY `USERROLEMAPINDEX` (`PRINCIPAL_NAME`,`ROLE_ID`,`GRANTOR`,`GRANTOR_TYPE`),
  KEY `ROLE_MAP_N49` (`ROLE_ID`),
  CONSTRAINT `ROLE_MAP_FK1` FOREIGN KEY (`ROLE_ID`) REFERENCES `ROLES` (`ROLE_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `RUNTIME_STATS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `RUNTIME_STATS` (
  `RS_ID` bigint NOT NULL,
  `CREATE_TIME` bigint NOT NULL,
  `WEIGHT` bigint NOT NULL,
  `PAYLOAD` blob,
  PRIMARY KEY (`RS_ID`),
  KEY `IDX_RUNTIME_STATS_CREATE_TIME` (`CREATE_TIME`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SCHEMA_VERSION`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SCHEMA_VERSION` (
  `SCHEMA_VERSION_ID` bigint NOT NULL,
  `SCHEMA_ID` bigint DEFAULT NULL,
  `VERSION` int NOT NULL,
  `CREATED_AT` bigint NOT NULL,
  `CD_ID` bigint DEFAULT NULL,
  `STATE` int NOT NULL,
  `DESCRIPTION` varchar(4000) DEFAULT NULL,
  `SCHEMA_TEXT` mediumtext,
  `FINGERPRINT` varchar(256) DEFAULT NULL,
  `SCHEMA_VERSION_NAME` varchar(256) DEFAULT NULL,
  `SERDE_ID` bigint DEFAULT NULL,
  PRIMARY KEY (`SCHEMA_VERSION_ID`),
  KEY `UNIQUE_VERSION` (`SCHEMA_ID`,`VERSION`),
  KEY `SIIndex` (`SCHEMA_ID`),
  KEY `SERDEIDIndex` (`SERDE_ID`),
  KEY `CDIDIndex` (`CD_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SDS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SDS` (
  `SD_ID` bigint NOT NULL,
  `CD_ID` bigint DEFAULT NULL,
  `INPUT_FORMAT` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `IS_COMPRESSED` bit(1) NOT NULL,
  `IS_STOREDASSUBDIRECTORIES` bit(1) NOT NULL,
  `LOCATION` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `NUM_BUCKETS` int NOT NULL,
  `OUTPUT_FORMAT` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `SERDE_ID` bigint DEFAULT NULL,
  `NAME` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PARENT_ID` bigint DEFAULT NULL,
  `PARTITION_ID` bigint DEFAULT NULL,
  PRIMARY KEY (`SD_ID`),
  KEY `SDS_N49` (`SERDE_ID`),
  KEY `SDS_N50` (`CD_ID`),
  KEY `INODE_SDS_FK` (`PARTITION_ID`,`PARENT_ID`,`NAME`),
  CONSTRAINT `INODE_SDS_FK` FOREIGN KEY (`PARTITION_ID`, `PARENT_ID`, `NAME`) REFERENCES `hops`.`hdfs_inodes` (`partition_id`, `parent_id`, `name`) ON DELETE CASCADE,
  CONSTRAINT `SDS_FK1` FOREIGN KEY (`SERDE_ID`) REFERENCES `SERDES` (`SERDE_ID`) ON DELETE CASCADE ON UPDATE RESTRICT,
  CONSTRAINT `SDS_FK2` FOREIGN KEY (`CD_ID`) REFERENCES `CDS` (`CD_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SD_PARAMS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SD_PARAMS` (
  `SD_ID` bigint NOT NULL,
  `PARAM_KEY` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `PARAM_VALUE` mediumtext CHARACTER SET latin1 COLLATE latin1_general_cs,
  PRIMARY KEY (`SD_ID`,`PARAM_KEY`),
  KEY `SD_PARAMS_N49` (`SD_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SEQUENCE_TABLE`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SEQUENCE_TABLE` (
  `SEQUENCE_NAME` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `NEXT_VAL` bigint NOT NULL,
  PRIMARY KEY (`SEQUENCE_NAME`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SERDES`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SERDES` (
  `SERDE_ID` bigint NOT NULL,
  `NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `SLIB` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `DESCRIPTION` varchar(2000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `SERIALIZER_CLASS` varchar(2000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `DESERIALIZER_CLASS` varchar(2000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `SERDE_TYPE` int DEFAULT NULL,
  PRIMARY KEY (`SERDE_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SERDE_PARAMS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SERDE_PARAMS` (
  `SERDE_ID` bigint NOT NULL,
  `PARAM_KEY` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `PARAM_VALUE` mediumtext CHARACTER SET latin1 COLLATE latin1_general_cs,
  PRIMARY KEY (`SERDE_ID`,`PARAM_KEY`),
  KEY `SERDE_PARAMS_N49` (`SERDE_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SKEWED_COL_NAMES`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SKEWED_COL_NAMES` (
  `SD_ID` bigint NOT NULL,
  `SKEWED_COL_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `INTEGER_IDX` int NOT NULL,
  PRIMARY KEY (`SD_ID`,`INTEGER_IDX`),
  KEY `SKEWED_COL_NAMES_N49` (`SD_ID`),
  CONSTRAINT `SKEWED_COL_NAMES_FK1` FOREIGN KEY (`SD_ID`) REFERENCES `SDS` (`SD_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SKEWED_COL_VALUE_LOC_MAP`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SKEWED_COL_VALUE_LOC_MAP` (
  `SD_ID` bigint NOT NULL,
  `STRING_LIST_ID_KID` bigint NOT NULL,
  `LOCATION` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`SD_ID`,`STRING_LIST_ID_KID`),
  KEY `SKEWED_COL_VALUE_LOC_MAP_N49` (`STRING_LIST_ID_KID`),
  KEY `SKEWED_COL_VALUE_LOC_MAP_N50` (`SD_ID`),
  CONSTRAINT `SKEWED_COL_VALUE_LOC_MAP_FK1` FOREIGN KEY (`SD_ID`) REFERENCES `SDS` (`SD_ID`) ON DELETE CASCADE ON UPDATE RESTRICT,
  CONSTRAINT `SKEWED_COL_VALUE_LOC_MAP_FK2` FOREIGN KEY (`STRING_LIST_ID_KID`) REFERENCES `SKEWED_STRING_LIST` (`STRING_LIST_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SKEWED_STRING_LIST`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SKEWED_STRING_LIST` (
  `STRING_LIST_ID` bigint NOT NULL,
  PRIMARY KEY (`STRING_LIST_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SKEWED_STRING_LIST_VALUES`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SKEWED_STRING_LIST_VALUES` (
  `STRING_LIST_ID` bigint NOT NULL,
  `STRING_LIST_VALUE` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `INTEGER_IDX` int NOT NULL,
  PRIMARY KEY (`STRING_LIST_ID`,`INTEGER_IDX`),
  KEY `SKEWED_STRING_LIST_VALUES_N49` (`STRING_LIST_ID`),
  CONSTRAINT `SKEWED_STRING_LIST_VALUES_FK1` FOREIGN KEY (`STRING_LIST_ID`) REFERENCES `SKEWED_STRING_LIST` (`STRING_LIST_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SKEWED_VALUES`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SKEWED_VALUES` (
  `SD_ID_OID` bigint NOT NULL,
  `STRING_LIST_ID_EID` bigint NOT NULL,
  `INTEGER_IDX` int NOT NULL,
  PRIMARY KEY (`SD_ID_OID`,`INTEGER_IDX`),
  KEY `SKEWED_VALUES_N50` (`SD_ID_OID`),
  KEY `SKEWED_VALUES_N49` (`STRING_LIST_ID_EID`),
  CONSTRAINT `SKEWED_VALUES_FK1` FOREIGN KEY (`SD_ID_OID`) REFERENCES `SDS` (`SD_ID`) ON DELETE CASCADE ON UPDATE RESTRICT,
  CONSTRAINT `SKEWED_VALUES_FK2` FOREIGN KEY (`STRING_LIST_ID_EID`) REFERENCES `SKEWED_STRING_LIST` (`STRING_LIST_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `SORT_COLS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `SORT_COLS` (
  `SD_ID` bigint NOT NULL,
  `COLUMN_NAME` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `ORDER` int NOT NULL,
  `INTEGER_IDX` int NOT NULL,
  PRIMARY KEY (`SD_ID`,`INTEGER_IDX`),
  KEY `SORT_COLS_N49` (`SD_ID`),
  CONSTRAINT `SORT_COLS_FK1` FOREIGN KEY (`SD_ID`) REFERENCES `SDS` (`SD_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TABLE_PARAMS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `TABLE_PARAMS` (
  `TBL_ID` bigint NOT NULL,
  `PARAM_KEY` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `PARAM_VALUE` mediumtext CHARACTER SET latin1 COLLATE latin1_general_cs,
  PRIMARY KEY (`TBL_ID`,`PARAM_KEY`),
  KEY `TABLE_PARAMS_N49` (`TBL_ID`),
  KEY `TPTIDIndex` (`TBL_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TAB_COL_STATS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `TAB_COL_STATS` (
  `CS_ID` bigint NOT NULL,
  `CAT_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `DB_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `TABLE_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `COLUMN_NAME` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `COLUMN_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `TBL_ID` bigint NOT NULL,
  `LONG_LOW_VALUE` bigint DEFAULT NULL,
  `LONG_HIGH_VALUE` bigint DEFAULT NULL,
  `DOUBLE_HIGH_VALUE` double(53,4) DEFAULT NULL,
  `DOUBLE_LOW_VALUE` double(53,4) DEFAULT NULL,
  `BIG_DECIMAL_LOW_VALUE` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `BIG_DECIMAL_HIGH_VALUE` varchar(4000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `NUM_NULLS` bigint NOT NULL,
  `NUM_DISTINCTS` bigint DEFAULT NULL,
  `BIT_VECTOR` blob,
  `AVG_COL_LEN` double(53,4) DEFAULT NULL,
  `MAX_COL_LEN` bigint DEFAULT NULL,
  `NUM_TRUES` bigint DEFAULT NULL,
  `NUM_FALSES` bigint DEFAULT NULL,
  `LAST_ANALYZED` bigint NOT NULL,
  PRIMARY KEY (`CS_ID`),
  KEY `TCSTIDIndex` (`TBL_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TBLS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `TBLS` (
  `TBL_ID` bigint NOT NULL,
  `CREATE_TIME` int NOT NULL,
  `DB_ID` bigint DEFAULT NULL,
  `LAST_ACCESS_TIME` int NOT NULL,
  `OWNER` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `OWNER_TYPE` varchar(10) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `RETENTION` int NOT NULL,
  `SD_ID` bigint DEFAULT NULL,
  `TBL_NAME` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `TBL_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `VIEW_EXPANDED_TEXT` mediumtext,
  `VIEW_ORIGINAL_TEXT` mediumtext,
  `IS_REWRITE_ENABLED` bit(1) NOT NULL DEFAULT b'0',
  PRIMARY KEY (`TBL_ID`),
  UNIQUE KEY `UNIQUETABLE` (`TBL_NAME`,`DB_ID`),
  KEY `TBLS_N50` (`SD_ID`),
  KEY `TBLS_N49` (`DB_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TBL_COL_PRIVS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `TBL_COL_PRIVS` (
  `TBL_COLUMN_GRANT_ID` bigint NOT NULL,
  `COLUMN_NAME` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `CREATE_TIME` int NOT NULL,
  `GRANT_OPTION` smallint NOT NULL,
  `GRANTOR` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `GRANTOR_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `TBL_COL_PRIV` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `TBL_ID` bigint DEFAULT NULL,
  PRIMARY KEY (`TBL_COLUMN_GRANT_ID`),
  KEY `TABLECOLUMNPRIVILEGEINDEX` (`TBL_ID`,`COLUMN_NAME`,`PRINCIPAL_NAME`,`PRINCIPAL_TYPE`,`TBL_COL_PRIV`,`GRANTOR`,`GRANTOR_TYPE`),
  KEY `TBL_COL_PRIVS_N49` (`TBL_ID`),
  CONSTRAINT `TBL_COL_PRIVS_FK1` FOREIGN KEY (`TBL_ID`) REFERENCES `TBLS` (`TBL_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TBL_PRIVS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `TBL_PRIVS` (
  `TBL_GRANT_ID` bigint NOT NULL,
  `CREATE_TIME` int NOT NULL,
  `GRANT_OPTION` smallint NOT NULL,
  `GRANTOR` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `GRANTOR_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `PRINCIPAL_TYPE` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `TBL_PRIV` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `TBL_ID` bigint DEFAULT NULL,
  PRIMARY KEY (`TBL_GRANT_ID`),
  KEY `TBL_PRIVS_N49` (`TBL_ID`),
  KEY `TABLEPRIVILEGEINDEX` (`TBL_ID`,`PRINCIPAL_NAME`,`PRINCIPAL_TYPE`,`TBL_PRIV`,`GRANTOR`,`GRANTOR_TYPE`),
  CONSTRAINT `TBL_PRIVS_FK1` FOREIGN KEY (`TBL_ID`) REFERENCES `TBLS` (`TBL_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TXNS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `TXNS` (
  `TXN_ID` bigint NOT NULL,
  `TXN_STATE` char(1) NOT NULL,
  `TXN_STARTED` bigint NOT NULL,
  `TXN_LAST_HEARTBEAT` bigint NOT NULL,
  `TXN_USER` varchar(128) NOT NULL,
  `TXN_HOST` varchar(128) NOT NULL,
  `TXN_AGENT_INFO` varchar(128) DEFAULT NULL,
  `TXN_META_INFO` varchar(128) DEFAULT NULL,
  `TXN_HEARTBEAT_COUNT` int DEFAULT NULL,
  PRIMARY KEY (`TXN_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TXN_COMPONENTS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `TXN_COMPONENTS` (
  `TC_TXNID` bigint NOT NULL,
  `TC_DATABASE` varchar(128) NOT NULL,
  `TC_TABLE` varchar(128) DEFAULT NULL,
  `TC_PARTITION` varchar(767) DEFAULT NULL,
  `TC_OPERATION_TYPE` char(1) NOT NULL,
  `TC_WRITEID` bigint DEFAULT NULL,
  KEY `TC_TXNID_INDEX` (`TC_TXNID`),
  CONSTRAINT `TXN_COMPONENTS_fk_1` FOREIGN KEY (`TC_TXNID`) REFERENCES `TXNS` (`TXN_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TXN_TO_WRITE_ID`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `TXN_TO_WRITE_ID` (
  `T2W_TXNID` bigint NOT NULL,
  `T2W_DATABASE` varchar(128) NOT NULL,
  `T2W_TABLE` varchar(256) NOT NULL,
  `T2W_WRITEID` bigint NOT NULL,
  UNIQUE KEY `TBL_TO_TXN_ID_IDX` (`T2W_DATABASE`,`T2W_TABLE`,`T2W_TXNID`),
  UNIQUE KEY `TBL_TO_WRITE_ID_IDX` (`T2W_DATABASE`,`T2W_TABLE`,`T2W_WRITEID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TYPES`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `TYPES` (
  `TYPES_ID` bigint NOT NULL,
  `TYPE_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `TYPE1` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `TYPE2` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`TYPES_ID`),
  UNIQUE KEY `UNIQUE_TYPE` (`TYPE_NAME`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `TYPE_FIELDS`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `TYPE_FIELDS` (
  `TYPE_NAME` bigint NOT NULL,
  `COMMENT` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `FIELD_NAME` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `FIELD_TYPE` varchar(767) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `INTEGER_IDX` int NOT NULL,
  PRIMARY KEY (`TYPE_NAME`,`FIELD_NAME`),
  KEY `TYPE_FIELDS_N49` (`TYPE_NAME`),
  CONSTRAINT `TYPE_FIELDS_FK1` FOREIGN KEY (`TYPE_NAME`) REFERENCES `TYPES` (`TYPES_ID`) ON DELETE CASCADE ON UPDATE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `VERSION`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `VERSION` (
  `VER_ID` bigint NOT NULL,
  `SCHEMA_VERSION` varchar(127) NOT NULL,
  `VERSION_COMMENT` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`VER_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `WM_MAPPING`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `WM_MAPPING` (
  `MAPPING_ID` bigint NOT NULL,
  `RP_ID` bigint NOT NULL,
  `ENTITY_TYPE` varchar(128) NOT NULL,
  `ENTITY_NAME` varchar(128) NOT NULL,
  `POOL_ID` bigint DEFAULT NULL,
  `ORDERING` int DEFAULT NULL,
  PRIMARY KEY (`MAPPING_ID`),
  UNIQUE KEY `UNIQUE_WM_MAPPING` (`RP_ID`,`ENTITY_TYPE`,`ENTITY_NAME`),
  KEY `WM_MAPPING_FK2` (`POOL_ID`),
  CONSTRAINT `WM_MAPPING_FK1` FOREIGN KEY (`RP_ID`) REFERENCES `WM_RESOURCEPLAN` (`RP_ID`),
  CONSTRAINT `WM_MAPPING_FK2` FOREIGN KEY (`POOL_ID`) REFERENCES `WM_POOL` (`POOL_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `WM_POOL`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `WM_POOL` (
  `POOL_ID` bigint NOT NULL,
  `RP_ID` bigint NOT NULL,
  `PATH` varchar(767) NOT NULL,
  `ALLOC_FRACTION` double DEFAULT NULL,
  `QUERY_PARALLELISM` int DEFAULT NULL,
  `SCHEDULING_POLICY` varchar(767) DEFAULT NULL,
  PRIMARY KEY (`POOL_ID`),
  UNIQUE KEY `UNIQUE_WM_POOL` (`RP_ID`,`PATH`),
  CONSTRAINT `WM_POOL_FK1` FOREIGN KEY (`RP_ID`) REFERENCES `WM_RESOURCEPLAN` (`RP_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `WM_POOL_TO_TRIGGER`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `WM_POOL_TO_TRIGGER` (
  `POOL_ID` bigint NOT NULL,
  `TRIGGER_ID` bigint NOT NULL,
  PRIMARY KEY (`POOL_ID`,`TRIGGER_ID`),
  KEY `WM_POOL_TO_TRIGGER_FK2` (`TRIGGER_ID`),
  CONSTRAINT `WM_POOL_TO_TRIGGER_FK1` FOREIGN KEY (`POOL_ID`) REFERENCES `WM_POOL` (`POOL_ID`),
  CONSTRAINT `WM_POOL_TO_TRIGGER_FK2` FOREIGN KEY (`TRIGGER_ID`) REFERENCES `WM_TRIGGER` (`TRIGGER_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `WM_RESOURCEPLAN`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `WM_RESOURCEPLAN` (
  `RP_ID` bigint NOT NULL,
  `NAME` varchar(128) NOT NULL,
  `QUERY_PARALLELISM` int DEFAULT NULL,
  `STATUS` varchar(20) NOT NULL,
  `DEFAULT_POOL_ID` bigint DEFAULT NULL,
  PRIMARY KEY (`RP_ID`),
  UNIQUE KEY `UNIQUE_WM_RESOURCEPLAN` (`NAME`),
  KEY `WM_RESOURCEPLAN_FK1` (`DEFAULT_POOL_ID`),
  CONSTRAINT `WM_RESOURCEPLAN_FK1` FOREIGN KEY (`DEFAULT_POOL_ID`) REFERENCES `WM_POOL` (`POOL_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `WM_TRIGGER`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `WM_TRIGGER` (
  `TRIGGER_ID` bigint NOT NULL,
  `RP_ID` bigint NOT NULL,
  `NAME` varchar(128) NOT NULL,
  `TRIGGER_EXPRESSION` varchar(1024) DEFAULT NULL,
  `ACTION_EXPRESSION` varchar(1024) DEFAULT NULL,
  `IS_IN_UNMANAGED` bit(1) NOT NULL DEFAULT b'0',
  PRIMARY KEY (`TRIGGER_ID`),
  UNIQUE KEY `UNIQUE_WM_TRIGGER` (`RP_ID`,`NAME`),
  CONSTRAINT `WM_TRIGGER_FK1` FOREIGN KEY (`RP_ID`) REFERENCES `WM_RESOURCEPLAN` (`RP_ID`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `WRITE_SET`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `WRITE_SET` (
  `WS_DATABASE` varchar(128) NOT NULL,
  `WS_TABLE` varchar(128) NOT NULL,
  `WS_PARTITION` varchar(767) DEFAULT NULL,
  `WS_TXNID` bigint NOT NULL,
  `WS_COMMIT_ID` bigint NOT NULL,
  `WS_OPERATION_TYPE` char(1) NOT NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping events for database 'metastore'
--

--
-- Dumping routines for database 'metastore'
--

--
-- Current Database: `airflow`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `airflow` /*!40100 DEFAULT CHARACTER SET latin1 */ /*!80016 DEFAULT ENCRYPTION='N' */;

USE `airflow`;

--
-- Table structure for table `alembic_version`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `alembic_version` (
  `version_num` varchar(32) NOT NULL,
  PRIMARY KEY (`version_num`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `chart`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `chart` (
  `id` int NOT NULL AUTO_INCREMENT,
  `label` varchar(200) DEFAULT NULL,
  `conn_id` varchar(250) NOT NULL,
  `user_id` int DEFAULT NULL,
  `chart_type` varchar(100) DEFAULT NULL,
  `sql_layout` varchar(50) DEFAULT NULL,
  `sql` text,
  `y_log_scale` tinyint(1) DEFAULT NULL,
  `show_datatable` tinyint(1) DEFAULT NULL,
  `show_sql` tinyint(1) DEFAULT NULL,
  `height` int DEFAULT NULL,
  `default_params` varchar(5000) DEFAULT NULL,
  `x_is_date` tinyint(1) DEFAULT NULL,
  `iteration_no` int DEFAULT NULL,
  `last_modified` timestamp(6) NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`),
  CONSTRAINT `chart_fk_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`),
  CONSTRAINT `chart_chk_1` CHECK ((`y_log_scale` in (0,1))),
  CONSTRAINT `chart_chk_2` CHECK ((`show_datatable` in (0,1))),
  CONSTRAINT `chart_chk_3` CHECK ((`show_sql` in (0,1))),
  CONSTRAINT `chart_chk_4` CHECK ((`x_is_date` in (0,1)))
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `connection`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `connection` (
  `id` int NOT NULL AUTO_INCREMENT,
  `conn_id` varchar(250) DEFAULT NULL,
  `conn_type` varchar(500) DEFAULT NULL,
  `host` varchar(500) DEFAULT NULL,
  `schema` varchar(500) DEFAULT NULL,
  `login` varchar(500) DEFAULT NULL,
  `password` varchar(5000) DEFAULT NULL,
  `port` int DEFAULT NULL,
  `extra` varchar(5000) DEFAULT NULL,
  `is_encrypted` tinyint(1) DEFAULT NULL,
  `is_extra_encrypted` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  CONSTRAINT `connection_chk_1` CHECK ((`is_encrypted` in (0,1))),
  CONSTRAINT `connection_chk_2` CHECK ((`is_extra_encrypted` in (0,1)))
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dag`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `dag` (
  `dag_id` varchar(250) NOT NULL,
  `is_paused` tinyint(1) DEFAULT NULL,
  `is_subdag` tinyint(1) DEFAULT NULL,
  `is_active` tinyint(1) DEFAULT NULL,
  `last_scheduler_run` timestamp(6) NULL DEFAULT NULL,
  `last_pickled` timestamp(6) NULL DEFAULT NULL,
  `last_expired` timestamp(6) NULL DEFAULT NULL,
  `scheduler_lock` tinyint(1) DEFAULT NULL,
  `pickle_id` int DEFAULT NULL,
  `fileloc` varchar(2000) DEFAULT NULL,
  `owners` varchar(2000) DEFAULT NULL,
  `description` text,
  `default_view` varchar(25) DEFAULT NULL,
  `schedule_interval` text,
  `root_dag_id` varchar(250) DEFAULT NULL,
  PRIMARY KEY (`dag_id`),
  KEY `idx_root_dag_id` (`root_dag_id`),
  CONSTRAINT `dag_chk_1` CHECK ((`is_paused` in (0,1))),
  CONSTRAINT `dag_chk_2` CHECK ((`is_subdag` in (0,1))),
  CONSTRAINT `dag_chk_3` CHECK ((`is_active` in (0,1))),
  CONSTRAINT `dag_chk_4` CHECK ((`scheduler_lock` in (0,1)))
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dag_code`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `dag_code` (
  `fileloc_hash` bigint NOT NULL,
  `fileloc` varchar(2000) NOT NULL,
  `source_code` text NOT NULL,
  `last_updated` timestamp NOT NULL,
  PRIMARY KEY (`fileloc_hash`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dag_pickle`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `dag_pickle` (
  `id` int NOT NULL AUTO_INCREMENT,
  `pickle` blob,
  `created_dttm` timestamp(6) NULL DEFAULT NULL,
  `pickle_hash` bigint DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dag_run`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `dag_run` (
  `id` int NOT NULL AUTO_INCREMENT,
  `dag_id` varchar(250) DEFAULT NULL,
  `execution_date` timestamp(6) NULL DEFAULT NULL,
  `state` varchar(50) DEFAULT NULL,
  `run_id` varchar(250) DEFAULT NULL,
  `external_trigger` tinyint(1) DEFAULT NULL,
  `conf` blob,
  `end_date` timestamp(6) NULL DEFAULT NULL,
  `start_date` timestamp(6) NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `dag_id` (`dag_id`,`execution_date`),
  UNIQUE KEY `dag_id_2` (`dag_id`,`run_id`),
  KEY `dag_id_state` (`dag_id`,`state`),
  CONSTRAINT `dag_run_chk_1` CHECK ((`external_trigger` in (0,1)))
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dag_tag`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `dag_tag` (
  `name` varchar(100) NOT NULL,
  `dag_id` varchar(250) NOT NULL,
  PRIMARY KEY (`name`,`dag_id`),
  KEY `dag_id` (`dag_id`),
  CONSTRAINT `dag_tag_fk_1` FOREIGN KEY (`dag_id`) REFERENCES `dag` (`dag_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `import_error`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `import_error` (
  `id` int NOT NULL AUTO_INCREMENT,
  `timestamp` timestamp(6) NULL DEFAULT NULL,
  `filename` varchar(1024) DEFAULT NULL,
  `stacktrace` text,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `job`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `job` (
  `id` int NOT NULL AUTO_INCREMENT,
  `dag_id` varchar(250) DEFAULT NULL,
  `state` varchar(20) DEFAULT NULL,
  `job_type` varchar(30) DEFAULT NULL,
  `start_date` timestamp(6) NULL DEFAULT NULL,
  `end_date` timestamp(6) NULL DEFAULT NULL,
  `latest_heartbeat` timestamp(6) NULL DEFAULT NULL,
  `executor_class` varchar(500) DEFAULT NULL,
  `hostname` varchar(500) DEFAULT NULL,
  `unixname` varchar(1000) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `job_type_heart` (`job_type`,`latest_heartbeat`),
  KEY `idx_job_state_heartbeat` (`state`,`latest_heartbeat`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `known_event`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `known_event` (
  `id` int NOT NULL AUTO_INCREMENT,
  `label` varchar(200) DEFAULT NULL,
  `start_date` datetime(6) DEFAULT NULL,
  `end_date` datetime(6) DEFAULT NULL,
  `user_id` int DEFAULT NULL,
  `known_event_type_id` int DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`),
  KEY `known_event_type_id` (`known_event_type_id`),
  KEY `user_id` (`user_id`),
  CONSTRAINT `known_event_fk_1` FOREIGN KEY (`known_event_type_id`) REFERENCES `known_event_type` (`id`),
  CONSTRAINT `known_event_fk_2` FOREIGN KEY (`user_id`) REFERENCES `users` (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `known_event_type`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `known_event_type` (
  `id` int NOT NULL AUTO_INCREMENT,
  `know_event_type` varchar(200) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `kube_resource_version`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `kube_resource_version` (
  `one_row_id` tinyint(1) NOT NULL DEFAULT '1',
  `resource_version` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`one_row_id`),
  CONSTRAINT `kube_resource_version_chk_1` CHECK ((`one_row_id` in (0,1))),
  CONSTRAINT `kube_resource_version_one_row_id` CHECK ((`one_row_id` <> 0))
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `kube_worker_uuid`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `kube_worker_uuid` (
  `one_row_id` tinyint(1) NOT NULL DEFAULT '1',
  `worker_uuid` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`one_row_id`),
  CONSTRAINT `kube_worker_one_row_id` CHECK ((`one_row_id` <> 0)),
  CONSTRAINT `kube_worker_uuid_chk_1` CHECK ((`one_row_id` in (0,1)))
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `log`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `log` (
  `id` int NOT NULL AUTO_INCREMENT,
  `dttm` timestamp(6) NULL DEFAULT NULL,
  `dag_id` varchar(250) DEFAULT NULL,
  `task_id` varchar(250) DEFAULT NULL,
  `event` varchar(30) DEFAULT NULL,
  `execution_date` timestamp(6) NULL DEFAULT NULL,
  `owner` varchar(500) DEFAULT NULL,
  `extra` text,
  PRIMARY KEY (`id`),
  KEY `idx_log_dag` (`dag_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `rendered_task_instance_fields`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `rendered_task_instance_fields` (
  `dag_id` varchar(250) NOT NULL,
  `task_id` varchar(250) NOT NULL,
  `execution_date` timestamp NOT NULL,
  `rendered_fields` json NOT NULL,
  PRIMARY KEY (`dag_id`,`task_id`,`execution_date`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `serialized_dag`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `serialized_dag` (
  `dag_id` varchar(250) NOT NULL,
  `fileloc` varchar(2000) NOT NULL,
  `fileloc_hash` bigint NOT NULL,
  `data` json NOT NULL,
  `last_updated` timestamp(6) NOT NULL,
  PRIMARY KEY (`dag_id`),
  KEY `idx_fileloc_hash` (`fileloc_hash`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `sla_miss`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `sla_miss` (
  `task_id` varchar(250) NOT NULL,
  `dag_id` varchar(250) NOT NULL,
  `execution_date` timestamp(6) NOT NULL,
  `email_sent` tinyint(1) DEFAULT NULL,
  `timestamp` timestamp(6) NULL DEFAULT NULL,
  `description` text,
  `notification_sent` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`task_id`,`dag_id`,`execution_date`),
  KEY `sm_dag` (`dag_id`),
  CONSTRAINT `sla_miss_chk_1` CHECK ((`email_sent` in (0,1))),
  CONSTRAINT `sla_miss_chk_2` CHECK ((`notification_sent` in (0,1)))
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `slot_pool`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `slot_pool` (
  `id` int NOT NULL AUTO_INCREMENT,
  `pool` varchar(50) DEFAULT NULL,
  `slots` int DEFAULT NULL,
  `description` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `pool` (`pool`)
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `task_fail`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `task_fail` (
  `id` int NOT NULL AUTO_INCREMENT,
  `task_id` varchar(250) NOT NULL,
  `dag_id` varchar(250) NOT NULL,
  `execution_date` timestamp(6) NOT NULL,
  `start_date` timestamp(6) NULL DEFAULT NULL,
  `end_date` timestamp(6) NULL DEFAULT NULL,
  `duration` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_task_fail_dag_task_date` (`dag_id`,`task_id`,`execution_date`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `task_instance`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `task_instance` (
  `task_id` varchar(250) NOT NULL,
  `dag_id` varchar(250) NOT NULL,
  `execution_date` timestamp(6) NOT NULL,
  `start_date` timestamp(6) NULL DEFAULT NULL,
  `end_date` timestamp(6) NULL DEFAULT NULL,
  `duration` float DEFAULT NULL,
  `state` varchar(20) DEFAULT NULL,
  `try_number` int DEFAULT NULL,
  `hostname` varchar(1000) DEFAULT NULL,
  `unixname` varchar(1000) DEFAULT NULL,
  `job_id` int DEFAULT NULL,
  `pool` varchar(50) NOT NULL,
  `queue` varchar(256) DEFAULT NULL,
  `priority_weight` int DEFAULT NULL,
  `operator` varchar(1000) DEFAULT NULL,
  `queued_dttm` timestamp(6) NULL DEFAULT NULL,
  `pid` int DEFAULT NULL,
  `max_tries` int DEFAULT '-1',
  `executor_config` blob,
  `pool_slots` int DEFAULT NULL,
  PRIMARY KEY (`task_id`,`dag_id`,`execution_date`),
  KEY `ti_dag_state` (`dag_id`,`state`),
  KEY `ti_pool` (`pool`,`state`,`priority_weight`),
  KEY `ti_state_lkp` (`dag_id`,`task_id`,`execution_date`,`state`),
  KEY `ti_state` (`state`),
  KEY `ti_job_id` (`job_id`),
  KEY `ti_dag_date` (`dag_id`,`execution_date`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `task_reschedule`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `task_reschedule` (
  `id` int NOT NULL AUTO_INCREMENT,
  `task_id` varchar(250) NOT NULL,
  `dag_id` varchar(250) NOT NULL,
  `execution_date` timestamp(6) NOT NULL,
  `try_number` int NOT NULL,
  `start_date` timestamp(6) NOT NULL,
  `end_date` timestamp(6) NOT NULL,
  `duration` int NOT NULL,
  `reschedule_date` timestamp(6) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_task_reschedule_dag_task_date` (`dag_id`,`task_id`,`execution_date`),
  KEY `task_reschedule_dag_task_date_fkey` (`task_id`,`dag_id`,`execution_date`),
  CONSTRAINT `task_reschedule_dag_task_date_fkey` FOREIGN KEY (`task_id`, `dag_id`, `execution_date`) REFERENCES `task_instance` (`task_id`, `dag_id`, `execution_date`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `users`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `users` (
  `id` int NOT NULL AUTO_INCREMENT,
  `username` varchar(250) DEFAULT NULL,
  `email` varchar(500) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `superuser` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `username` (`username`),
  CONSTRAINT `users_chk_1` CHECK ((`superuser` in (0,1)))
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `variable`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `variable` (
  `id` int NOT NULL AUTO_INCREMENT,
  `key` varchar(250) DEFAULT NULL,
  `val` mediumtext,
  `is_encrypted` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `key` (`key`),
  CONSTRAINT `variable_chk_1` CHECK ((`is_encrypted` in (0,1)))
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `xcom`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `xcom` (
  `id` int NOT NULL AUTO_INCREMENT,
  `key` varchar(512) DEFAULT NULL,
  `value` blob,
  `timestamp` timestamp(6) NOT NULL,
  `execution_date` timestamp(6) NOT NULL,
  `task_id` varchar(250) NOT NULL,
  `dag_id` varchar(250) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_xcom_dag_task_date` (`dag_id`,`task_id`,`execution_date`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping events for database 'airflow'
--

--
-- Dumping routines for database 'airflow'
--

--
-- Current Database: `hopsworks`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `hopsworks` /*!40100 DEFAULT CHARACTER SET latin1 */ /*!80016 DEFAULT ENCRYPTION='N' */;

USE `hopsworks`;

--
-- Table structure for table `account_audit`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `account_audit` (
  `log_id` bigint NOT NULL AUTO_INCREMENT,
  `initiator` int NOT NULL,
  `target` int NOT NULL,
  `action` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `action_timestamp` timestamp NULL DEFAULT NULL,
  `message` varchar(100) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `outcome` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `ip` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `useragent` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`log_id`),
  KEY `initiator` (`initiator`),
  KEY `target` (`target`),
  CONSTRAINT `FK_257_274` FOREIGN KEY (`initiator`) REFERENCES `users` (`uid`),
  CONSTRAINT `FK_257_275` FOREIGN KEY (`target`) REFERENCES `users` (`uid`)
) ENGINE=ndbcluster AUTO_INCREMENT=1539 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `activity`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `activity` (
  `id` int NOT NULL AUTO_INCREMENT,
  `activity` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `user_id` int NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `flag` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `project_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `project_id` (`project_id`),
  KEY `user_id` (`user_id`),
  CONSTRAINT `FK_257_296` FOREIGN KEY (`user_id`) REFERENCES `users` (`uid`),
  CONSTRAINT `FK_284_295` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=2571 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `alert_manager_config`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `alert_manager_config` (
  `id` int NOT NULL AUTO_INCREMENT,
  `content` mediumblob NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `alert_receiver`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `alert_receiver` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(128) COLLATE latin1_general_cs NOT NULL,
  `config` blob NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name_UNIQUE` (`name`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `api_key`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `api_key` (
  `id` int NOT NULL AUTO_INCREMENT,
  `prefix` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `secret` varchar(512) COLLATE latin1_general_cs NOT NULL,
  `salt` varchar(256) COLLATE latin1_general_cs NOT NULL,
  `created` timestamp NOT NULL,
  `modified` timestamp NOT NULL,
  `name` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `user_id` int NOT NULL,
  `reserved` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `prefix_UNIQUE` (`prefix`),
  UNIQUE KEY `index4` (`user_id`,`name`),
  KEY `fk_api_key_1_idx` (`user_id`),
  CONSTRAINT `fk_api_key_1` FOREIGN KEY (`user_id`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `api_key_scope`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `api_key_scope` (
  `id` int NOT NULL AUTO_INCREMENT,
  `api_key` int NOT NULL,
  `scope` varchar(45) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `index2` (`api_key`,`scope`),
  CONSTRAINT `fk_api_key_scope_1` FOREIGN KEY (`api_key`) REFERENCES `api_key` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `banner`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `banner` (
  `id` int NOT NULL AUTO_INCREMENT,
  `message` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `created_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `active` tinyint NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `base_image`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `base_image` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `image_name` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `image_tag` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `description` varchar(1024) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `type` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `preinstalled` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_name` (`name`)
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `bbc_group`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `bbc_group` (
  `group_name` varchar(20) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `group_desc` varchar(200) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `gid` int NOT NULL,
  PRIMARY KEY (`gid`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `brewer_chat`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `brewer_chat` (
  `id` int NOT NULL AUTO_INCREMENT,
  `created` bigint NOT NULL,
  `modified` bigint NOT NULL,
  `title` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `user` int NOT NULL,
  `project` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `brewer_user` (`user`),
  KEY `brewer_project` (`project`),
  CONSTRAINT `brewer_project_fkc` FOREIGN KEY (`project`) REFERENCES `project` (`id`) ON DELETE CASCADE,
  CONSTRAINT `brewer_user_fkc` FOREIGN KEY (`user`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=2058 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `cached_feature`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `cached_feature` (
  `id` int NOT NULL AUTO_INCREMENT,
  `cached_feature_group_id` int DEFAULT NULL,
  `stream_feature_group_id` int DEFAULT NULL,
  `name` varchar(63) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `description` varchar(256) COLLATE latin1_general_cs DEFAULT '',
  `type` varchar(20000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `partition_key` tinyint(1) DEFAULT '0',
  `default_value` varchar(400) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `cached_feature_group_fk` (`cached_feature_group_id`),
  KEY `stream_feature_group_fk` (`stream_feature_group_id`),
  CONSTRAINT `cached_feature_group_fk2` FOREIGN KEY (`cached_feature_group_id`) REFERENCES `cached_feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `stream_feature_group_fk2` FOREIGN KEY (`stream_feature_group_id`) REFERENCES `stream_feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `cached_feature_extra_constraints`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `cached_feature_extra_constraints` (
  `id` int NOT NULL AUTO_INCREMENT,
  `cached_feature_group_id` int DEFAULT NULL,
  `stream_feature_group_id` int DEFAULT NULL,
  `name` varchar(63) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `primary_column` tinyint(1) NOT NULL DEFAULT '0',
  `hudi_precombine_key` tinyint(1) NOT NULL DEFAULT '0',
  `foreign_column` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `cached_feature_group_fk` (`cached_feature_group_id`),
  KEY `stream_feature_group_fk` (`stream_feature_group_id`),
  CONSTRAINT `cached_feature_group_constraint_fk` FOREIGN KEY (`cached_feature_group_id`) REFERENCES `cached_feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `stream_feature_group_constraint_fk` FOREIGN KEY (`stream_feature_group_id`) REFERENCES `stream_feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `cached_feature_group`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `cached_feature_group` (
  `id` int NOT NULL AUTO_INCREMENT,
  `timetravel_format` int NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `cloud_role_mapping`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `cloud_role_mapping` (
  `id` int NOT NULL AUTO_INCREMENT,
  `project_id` int NOT NULL,
  `project_role` varchar(32) COLLATE latin1_general_cs NOT NULL,
  `cloud_role` varchar(2048) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `index3` (`project_id`,`cloud_role`),
  UNIQUE KEY `index4` (`id`,`project_id`,`project_role`),
  KEY `fk_cloud_role_mapping_1_idx` (`project_id`),
  CONSTRAINT `fk_cloud_role_mapping_1` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `cloud_role_mapping_default`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `cloud_role_mapping_default` (
  `id` int NOT NULL AUTO_INCREMENT,
  `mapping_id` int NOT NULL,
  `project_id` int NOT NULL,
  `project_role` varchar(32) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `index3` (`project_id`,`project_role`),
  UNIQUE KEY `index4` (`mapping_id`,`project_id`,`project_role`),
  KEY `fk_cloud_role_mapping_default_1_idx` (`mapping_id`,`project_id`,`project_role`),
  CONSTRAINT `fk_cloud_role_mapping_default_1` FOREIGN KEY (`mapping_id`, `project_id`, `project_role`) REFERENCES `cloud_role_mapping` (`id`, `project_id`, `project_role`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `cluster_cert`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `cluster_cert` (
  `id` int NOT NULL AUTO_INCREMENT,
  `agent_id` int NOT NULL,
  `common_name` varchar(64) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `organization_name` varchar(64) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `organizational_unit_name` varchar(64) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `serial_number` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `registration_status` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `validation_key` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `validation_key_date` timestamp NULL DEFAULT NULL,
  `registration_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `organization_name` (`organization_name`,`organizational_unit_name`),
  UNIQUE KEY `serial_number` (`serial_number`),
  KEY `agent_id` (`agent_id`),
  CONSTRAINT `FK_257_552` FOREIGN KEY (`agent_id`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=7 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `command_search_fs`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `command_search_fs` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `inode_id` bigint NOT NULL,
  `project_id` int DEFAULT NULL,
  `op` varchar(20) COLLATE latin1_general_cs NOT NULL,
  `status` varchar(20) COLLATE latin1_general_cs NOT NULL,
  `feature_group_id` int DEFAULT NULL,
  `feature_view_id` int DEFAULT NULL,
  `training_dataset_id` int DEFAULT NULL,
  `error_message` varchar(10000) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_command_search_feature_group` (`feature_group_id`),
  KEY `fk_command_search_feature_view` (`feature_view_id`),
  KEY `fk_command_search_training_dataset` (`training_dataset_id`),
  CONSTRAINT `fk_command_search_feature_group` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE SET NULL,
  CONSTRAINT `fk_command_search_feature_view` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE SET NULL,
  CONSTRAINT `fk_command_search_training_dataset` FOREIGN KEY (`training_dataset_id`) REFERENCES `training_dataset` (`id`) ON DELETE SET NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `command_search_fs_history`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `command_search_fs_history` (
  `h_id` bigint NOT NULL AUTO_INCREMENT,
  `executed` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `id` bigint NOT NULL,
  `inode_id` bigint NOT NULL,
  `project_id` int DEFAULT NULL,
  `op` varchar(20) COLLATE latin1_general_cs NOT NULL,
  `status` varchar(20) COLLATE latin1_general_cs NOT NULL,
  `feature_group_id` int DEFAULT NULL,
  `feature_view_id` int DEFAULT NULL,
  `training_dataset_id` int DEFAULT NULL,
  `error_message` varchar(10000) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`h_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `conda_commands`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `conda_commands` (
  `id` int NOT NULL AUTO_INCREMENT,
  `op` varchar(52) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `channel_url` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `arg` varchar(11000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `lib` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `version` varchar(52) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `status` varchar(52) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `created` timestamp(3) NOT NULL DEFAULT CURRENT_TIMESTAMP(3),
  `install_type` varchar(52) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `environment_file` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `custom_commands_file` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `git_api_key_name` varchar(125) COLLATE latin1_general_cs DEFAULT NULL,
  `git_backend` varchar(45) COLLATE latin1_general_cs DEFAULT NULL,
  `user_id` int DEFAULT NULL,
  `error_message` varchar(10000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `environment_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `environment_id` (`environment_id`),
  KEY `user_fk_conda` (`user_id`),
  CONSTRAINT `user_fk_conda` FOREIGN KEY (`user_id`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1056 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `data_source`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `data_source` (
  `id` int NOT NULL AUTO_INCREMENT,
  `query` varchar(26000) COLLATE latin1_general_cs DEFAULT NULL,
  `database_name` varchar(100) COLLATE latin1_general_cs DEFAULT NULL,
  `group_name` varchar(100) COLLATE latin1_general_cs DEFAULT NULL,
  `table_name` varchar(100) COLLATE latin1_general_cs DEFAULT NULL,
  `path` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `connector_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `ds_connector_fk` (`connector_id`),
  CONSTRAINT `ds_connector_fk` FOREIGN KEY (`connector_id`) REFERENCES `feature_store_connector` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `databricks_instance`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `databricks_instance` (
  `id` int NOT NULL AUTO_INCREMENT,
  `url` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `uid` int NOT NULL,
  `secret_name` varchar(200) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  KEY `db_secret_fk` (`uid`,`secret_name`),
  CONSTRAINT `databricks_instance_fk_1` FOREIGN KEY (`uid`, `secret_name`) REFERENCES `secrets` (`uid`, `secret_name`) ON DELETE CASCADE,
  CONSTRAINT `databricks_instance_fk_2` FOREIGN KEY (`uid`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dataset`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `dataset` (
  `id` int NOT NULL AUTO_INCREMENT,
  `inode_name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `projectId` int NOT NULL,
  `description` varchar(2000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `searchable` tinyint(1) NOT NULL DEFAULT '0',
  `public_ds` tinyint(1) NOT NULL DEFAULT '0',
  `public_ds_id` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT '0',
  `dstype` int NOT NULL DEFAULT '0',
  `feature_store_id` int DEFAULT NULL,
  `permission` varchar(45) COLLATE latin1_general_cs NOT NULL DEFAULT 'READ_ONLY',
  PRIMARY KEY (`id`),
  KEY `projectId_name` (`projectId`,`inode_name`),
  KEY `featurestore_fk` (`feature_store_id`),
  KEY `dataset_name` (`inode_name`),
  CONSTRAINT `featurestore_fk` FOREIGN KEY (`feature_store_id`) REFERENCES `feature_store` (`id`) ON DELETE SET NULL,
  CONSTRAINT `FK_284_434` FOREIGN KEY (`projectId`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1771 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dataset_request`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `dataset_request` (
  `id` int NOT NULL AUTO_INCREMENT,
  `dataset` int NOT NULL,
  `projectId` int NOT NULL,
  `user_email` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `requested` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `message` varchar(3000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `message_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `index2` (`dataset`,`projectId`),
  KEY `projectId` (`projectId`,`user_email`),
  KEY `message_id` (`message_id`),
  CONSTRAINT `FK_302_451` FOREIGN KEY (`projectId`, `user_email`) REFERENCES `project_team` (`project_id`, `team_member`) ON DELETE CASCADE,
  CONSTRAINT `FK_429_449` FOREIGN KEY (`dataset`) REFERENCES `dataset` (`id`) ON DELETE CASCADE,
  CONSTRAINT `FK_438_452` FOREIGN KEY (`message_id`) REFERENCES `message` (`id`)
) ENGINE=ndbcluster AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dataset_shared_with`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `dataset_shared_with` (
  `id` int NOT NULL AUTO_INCREMENT,
  `dataset` int NOT NULL,
  `project` int NOT NULL,
  `accepted` tinyint(1) NOT NULL DEFAULT '0',
  `shared_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `permission` varchar(45) NOT NULL DEFAULT 'READ_ONLY',
  `shared_by` int DEFAULT NULL,
  `accepted_by` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `index2` (`dataset`,`project`),
  KEY `fk_dataset_shared_with_2_idx` (`project`),
  KEY `fk_shared_by` (`shared_by`),
  KEY `fk_accepted_by` (`accepted_by`),
  CONSTRAINT `fk_accepted_by` FOREIGN KEY (`accepted_by`) REFERENCES `users` (`uid`),
  CONSTRAINT `fk_dataset_shared_with_1` FOREIGN KEY (`dataset`) REFERENCES `dataset` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_dataset_shared_with_2` FOREIGN KEY (`project`) REFERENCES `project` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_shared_by` FOREIGN KEY (`shared_by`) REFERENCES `users` (`uid`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `default_job_configuration`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `default_job_configuration` (
  `project_id` int NOT NULL,
  `type` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `config` varchar(12500) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`project_id`,`type`),
  CONSTRAINT `FK_JOBCONFIG_PROJECT` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `embedding`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `embedding` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_group_id` int NOT NULL,
  `col_prefix` varchar(255) COLLATE latin1_general_cs DEFAULT NULL,
  `vector_db_index_name` varchar(255) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  KEY `feature_group_id` (`feature_group_id`),
  CONSTRAINT `feature_group_embedding_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `embedding_feature`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `embedding_feature` (
  `id` int NOT NULL AUTO_INCREMENT,
  `embedding_id` int NOT NULL,
  `name` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `dimension` int NOT NULL,
  `similarity_function_type` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `model_version_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `embedding_id` (`embedding_id`),
  KEY `embedding_feature_model_version_fk` (`model_version_id`),
  CONSTRAINT `embedding_feature_fk` FOREIGN KEY (`embedding_id`) REFERENCES `embedding` (`id`) ON DELETE CASCADE,
  CONSTRAINT `embedding_feature_model_version_fk` FOREIGN KEY (`model_version_id`) REFERENCES `model_version` (`id`) ON DELETE SET NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `environment`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `environment` (
  `id` int NOT NULL AUTO_INCREMENT,
  `project_id` int DEFAULT NULL,
  `name` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `description` varchar(1024) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `python_version` varchar(25) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `jupyter_conflicts` tinyint(1) NOT NULL DEFAULT '0',
  `conflicts` varchar(12000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `base_image_id` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `project_env_name` (`project_id`,`name`),
  KEY `base_image_fk` (`base_image_id`),
  CONSTRAINT `base_image_fk` FOREIGN KEY (`base_image_id`) REFERENCES `base_image` (`id`) ON DELETE CASCADE,
  CONSTRAINT `env_project_fk` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `environment_history`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `environment_history` (
  `id` int NOT NULL AUTO_INCREMENT,
  `environment_id` int NOT NULL,
  `docker_image` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `downgraded` varchar(7000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `installed` varchar(7000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `uninstalled` varchar(7000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `upgraded` varchar(7000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `previous_docker_image` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `user` int NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `environment_id` (`environment_id`),
  CONSTRAINT `history_environment_fk` FOREIGN KEY (`environment_id`) REFERENCES `environment` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `environment_python_libraries`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `environment_python_libraries` (
  `environment_id` int NOT NULL,
  `python_library_id` int NOT NULL,
  PRIMARY KEY (`environment_id`,`python_library_id`),
  KEY `python_library_id` (`python_library_id`),
  CONSTRAINT `environment_fk` FOREIGN KEY (`environment_id`) REFERENCES `environment` (`id`) ON DELETE CASCADE,
  CONSTRAINT `FK_505_514` FOREIGN KEY (`python_library_id`) REFERENCES `python_library` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (environment_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `executions`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `executions` (
  `id` int NOT NULL AUTO_INCREMENT,
  `submission_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `user` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `state` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `execution_start` bigint DEFAULT NULL,
  `execution_stop` bigint DEFAULT NULL,
  `stdout_path` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `stderr_path` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `notebook_out_path` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `hdfs_user` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `args` varchar(10000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT '',
  `app_id` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `job_id` int NOT NULL,
  `finalStatus` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT 'UNDEFINED',
  `progress` float NOT NULL DEFAULT '0',
  `resource_manager` tinyint(1) NOT NULL DEFAULT '0',
  `spark_app_id_internal` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `ray_dashboard_url` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `ray_cluster_name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `app_id` (`app_id`),
  KEY `job_id` (`job_id`),
  KEY `user` (`user`),
  KEY `submission_time_idx` (`submission_time`,`job_id`),
  KEY `state_idx` (`state`,`job_id`),
  KEY `finalStatus_idx` (`finalStatus`,`job_id`),
  KEY `progress_idx` (`progress`,`job_id`),
  CONSTRAINT `FK_262_366` FOREIGN KEY (`user`) REFERENCES `users` (`email`)
) ENGINE=ndbcluster AUTO_INCREMENT=23 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `expectation`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `expectation` (
  `id` int NOT NULL AUTO_INCREMENT,
  `expectation_suite_id` int NOT NULL,
  `expectation_type` varchar(150) COLLATE latin1_general_cs NOT NULL,
  `kwargs` varchar(5000) COLLATE latin1_general_cs NOT NULL,
  `meta` varchar(1000) COLLATE latin1_general_cs DEFAULT '{}',
  PRIMARY KEY (`id`),
  KEY `suite_fk` (`expectation_suite_id`),
  CONSTRAINT `suite_fk` FOREIGN KEY (`expectation_suite_id`) REFERENCES `expectation_suite` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `expectation_suite`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `expectation_suite` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_group_id` int NOT NULL,
  `name` varchar(63) COLLATE latin1_general_cs NOT NULL,
  `meta` varchar(1000) COLLATE latin1_general_cs DEFAULT '{}',
  `data_asset_type` varchar(50) COLLATE latin1_general_cs DEFAULT NULL,
  `ge_cloud_id` varchar(200) COLLATE latin1_general_cs DEFAULT NULL,
  `run_validation` tinyint(1) DEFAULT '1',
  `validation_ingestion_policy` varchar(25) COLLATE latin1_general_cs DEFAULT NULL,
  `created_at` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `feature_group_suite_fk` (`feature_group_id`),
  CONSTRAINT `feature_group_suite_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_descriptive_statistics`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_descriptive_statistics` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_name` varchar(232) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `feature_type` varchar(20) COLLATE latin1_general_cs DEFAULT NULL,
  `count` bigint DEFAULT NULL,
  `completeness` float DEFAULT NULL,
  `num_non_null_values` bigint DEFAULT NULL,
  `num_null_values` bigint DEFAULT NULL,
  `approx_num_distinct_values` bigint DEFAULT NULL,
  `min` double DEFAULT NULL,
  `max` double DEFAULT NULL,
  `sum` double DEFAULT NULL,
  `mean` double DEFAULT NULL,
  `stddev` double DEFAULT NULL,
  `percentiles` blob,
  `distinctness` float DEFAULT NULL,
  `entropy` float DEFAULT NULL,
  `uniqueness` float DEFAULT NULL,
  `exact_num_distinct_values` bigint DEFAULT NULL,
  `extended_statistics_path` varchar(255) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `feature_name` (`feature_name`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_group`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_group` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(63) COLLATE latin1_general_cs NOT NULL,
  `feature_store_id` int NOT NULL,
  `created` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `creator` int NOT NULL,
  `version` int NOT NULL,
  `description` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `feature_group_type` int NOT NULL DEFAULT '0',
  `on_demand_feature_group_id` int DEFAULT NULL,
  `cached_feature_group_id` int DEFAULT NULL,
  `stream_feature_group_id` int DEFAULT NULL,
  `event_time` varchar(63) COLLATE latin1_general_cs DEFAULT NULL,
  `online_enabled` tinyint(1) DEFAULT NULL,
  `topic_name` varchar(255) COLLATE latin1_general_cs DEFAULT NULL,
  `notification_topic_name` varchar(255) COLLATE latin1_general_cs DEFAULT NULL,
  `deprecated` tinyint(1) DEFAULT '0',
  `for_log` tinyint(1) NOT NULL DEFAULT '0',
  `connector_id` int DEFAULT NULL,
  `data_source_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name_version` (`feature_store_id`,`name`,`version`),
  KEY `feature_store_id` (`feature_store_id`),
  KEY `creator` (`creator`),
  KEY `on_demand_feature_group_fk` (`on_demand_feature_group_id`),
  KEY `cached_feature_group_fk` (`cached_feature_group_id`),
  KEY `stream_feature_group_fk` (`stream_feature_group_id`),
  KEY `connector_fk` (`connector_id`),
  KEY `data_source_fk` (`data_source_id`),
  CONSTRAINT `cached_feature_group_fk` FOREIGN KEY (`cached_feature_group_id`) REFERENCES `cached_feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `connector_fk` FOREIGN KEY (`connector_id`) REFERENCES `feature_store_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `data_source_fk` FOREIGN KEY (`data_source_id`) REFERENCES `data_source` (`id`) ON DELETE CASCADE,
  CONSTRAINT `FK_1012_790` FOREIGN KEY (`creator`) REFERENCES `users` (`uid`),
  CONSTRAINT `FK_656_740` FOREIGN KEY (`feature_store_id`) REFERENCES `feature_store` (`id`) ON DELETE CASCADE,
  CONSTRAINT `on_demand_feature_group_fk2` FOREIGN KEY (`on_demand_feature_group_id`) REFERENCES `on_demand_feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `stream_feature_group_fk` FOREIGN KEY (`stream_feature_group_id`) REFERENCES `stream_feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=13 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_group_alert`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_group_alert` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_group_id` int NOT NULL,
  `status` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `type` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `severity` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `receiver` int NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_feature_group_alert` (`feature_group_id`,`status`),
  KEY `fk_feature_group_alert_2_idx` (`feature_group_id`),
  KEY `fk_feature_group_alert_1_idx` (`receiver`),
  CONSTRAINT `fk_feature_group_alert_1` FOREIGN KEY (`receiver`) REFERENCES `alert_receiver` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_feature_group_alert_2` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_group_commit`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_group_commit` (
  `feature_group_id` int NOT NULL,
  `commit_id` bigint NOT NULL AUTO_INCREMENT,
  `committed_on` timestamp(6) NOT NULL,
  `num_rows_updated` int DEFAULT '0',
  `num_rows_inserted` int DEFAULT '0',
  `num_rows_deleted` int DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`feature_group_id`,`commit_id`),
  KEY `commit_id_idx` (`commit_id`),
  KEY `commit_date_idx` (`committed_on`),
  CONSTRAINT `feature_group_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_group_descriptive_statistics`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_group_descriptive_statistics` (
  `feature_group_statistics_id` int NOT NULL,
  `feature_descriptive_statistics_id` int NOT NULL,
  PRIMARY KEY (`feature_group_statistics_id`,`feature_descriptive_statistics_id`),
  KEY `fgds_fds_fk` (`feature_descriptive_statistics_id`),
  CONSTRAINT `fgds_fds_fk` FOREIGN KEY (`feature_descriptive_statistics_id`) REFERENCES `feature_descriptive_statistics` (`id`),
  CONSTRAINT `fgds_fgs_fk` FOREIGN KEY (`feature_group_statistics_id`) REFERENCES `feature_group_statistics` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_group_link`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_group_link` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_group_id` int NOT NULL,
  `parent_feature_group_id` int DEFAULT NULL,
  `parent_feature_store` varchar(100) COLLATE latin1_general_cs NOT NULL,
  `parent_feature_group_name` varchar(63) COLLATE latin1_general_cs NOT NULL,
  `parent_feature_group_version` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `link_unique` (`feature_group_id`,`parent_feature_group_id`),
  KEY `feature_group_id_fkc` (`feature_group_id`),
  KEY `parent_feature_group_id_fkc` (`parent_feature_group_id`),
  CONSTRAINT `feature_group_id_fkc` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `feature_group_parent_fkc` FOREIGN KEY (`parent_feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE SET NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_group_statistics`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_group_statistics` (
  `id` int NOT NULL AUTO_INCREMENT,
  `computation_time` datetime(3) NOT NULL,
  `feature_group_id` int NOT NULL,
  `row_percentage` decimal(6,5) NOT NULL DEFAULT '1.00000',
  `window_start_commit_time` bigint NOT NULL DEFAULT '0',
  `window_end_commit_time` bigint NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `window_commit_times_row_perc_fk` (`feature_group_id`,`window_start_commit_time`,`window_end_commit_time`,`row_percentage`),
  KEY `feature_group_id` (`feature_group_id`),
  CONSTRAINT `fgs_fg_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_group_transformation_functions`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_group_transformation_functions` (
  `id` int NOT NULL AUTO_INCREMENT,
  `transformation_function_id` int NOT NULL,
  `feature_group_id` int NOT NULL,
  `features` varchar(5004) COLLATE latin1_general_cs NOT NULL,
  `output_features` varchar(5004) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fgtf_fgi_fk` (`feature_group_id`),
  KEY `fgtf_tfi_fk` (`transformation_function_id`),
  CONSTRAINT `fgtf_fgi_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fgtf_tfi_fk` FOREIGN KEY (`transformation_function_id`) REFERENCES `transformation_function` (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_monitoring_config`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_monitoring_config` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_group_id` int DEFAULT NULL,
  `feature_view_id` int DEFAULT NULL,
  `name` varchar(63) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `description` varchar(2000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `feature_name` varchar(63) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `feature_monitoring_type` tinyint NOT NULL,
  `job_id` int NOT NULL,
  `job_schedule_id` int DEFAULT NULL,
  `detection_window_config_id` int DEFAULT NULL,
  `reference_window_config_id` int DEFAULT NULL,
  `statistics_comparison_config_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `config_name_UNIQUE` (`name`,`feature_group_id`,`feature_view_id`),
  KEY `feature_name` (`feature_name`),
  KEY `name` (`name`),
  KEY `fg_monitoring_config_fk` (`feature_group_id`),
  KEY `fv_monitoring_config_fk` (`feature_view_id`),
  KEY `job_monitoring_config_fk` (`job_id`),
  KEY `detection_window_config_monitoring_config_fk` (`detection_window_config_id`),
  KEY `reference_window_config_monitoring_config_fk` (`reference_window_config_id`),
  KEY `statistics_comparison_config_monitoring_config_fk` (`statistics_comparison_config_id`),
  KEY `job_schedule_fk` (`job_schedule_id`),
  CONSTRAINT `detection_window_config_monitoring_config_fk` FOREIGN KEY (`detection_window_config_id`) REFERENCES `monitoring_window_config` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fg_monitoring_config_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fv_monitoring_config_fk` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE,
  CONSTRAINT `job_monitoring_config_fk` FOREIGN KEY (`job_id`) REFERENCES `jobs` (`id`) ON DELETE CASCADE,
  CONSTRAINT `job_schedule_fk` FOREIGN KEY (`job_schedule_id`) REFERENCES `job_schedule` (`id`) ON DELETE CASCADE,
  CONSTRAINT `reference_window_config_monitoring_config_fk` FOREIGN KEY (`reference_window_config_id`) REFERENCES `monitoring_window_config` (`id`) ON DELETE CASCADE,
  CONSTRAINT `statistics_comparison_config_monitoring_config_fk` FOREIGN KEY (`statistics_comparison_config_id`) REFERENCES `statistics_comparison_config` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_monitoring_result`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_monitoring_result` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_monitoring_config_id` int NOT NULL,
  `feature_name` varchar(63) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `execution_id` int NOT NULL,
  `monitoring_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `shift_detected` tinyint(1) DEFAULT '0',
  `detection_stats_id` int DEFAULT NULL,
  `reference_stats_id` int DEFAULT NULL,
  `difference` float DEFAULT NULL,
  `specific_value` float DEFAULT NULL,
  `empty_detection_window` tinyint(1) DEFAULT '0',
  `empty_reference_window` tinyint(1) DEFAULT '0',
  `raised_exception` tinyint(1) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `config_monitoring_result_fk` (`feature_monitoring_config_id`),
  KEY `detection_stats_monitoring_result_fk` (`detection_stats_id`),
  KEY `reference_stats_monitoring_result_fk` (`reference_stats_id`),
  CONSTRAINT `config_monitoring_result_fk` FOREIGN KEY (`feature_monitoring_config_id`) REFERENCES `feature_monitoring_config` (`id`) ON DELETE CASCADE,
  CONSTRAINT `detection_stats_monitoring_result_fk` FOREIGN KEY (`detection_stats_id`) REFERENCES `feature_descriptive_statistics` (`id`),
  CONSTRAINT `reference_stats_monitoring_result_fk` FOREIGN KEY (`reference_stats_id`) REFERENCES `feature_descriptive_statistics` (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(100) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `project_id` int NOT NULL,
  `created` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `project_id` (`project_id`),
  CONSTRAINT `FK_883_662` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1091 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_activity`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_activity` (
  `id` int NOT NULL AUTO_INCREMENT,
  `event_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `uid` int NOT NULL,
  `type` int NOT NULL,
  `meta_type` int DEFAULT NULL,
  `meta_msg` varchar(15000) COLLATE latin1_general_cs DEFAULT NULL,
  `execution_id` int DEFAULT NULL,
  `commit_id` bigint DEFAULT NULL,
  `feature_group_id` int DEFAULT NULL,
  `training_dataset_id` int DEFAULT NULL,
  `feature_view_id` int DEFAULT NULL,
  `expectation_suite_id` int DEFAULT NULL,
  `validation_report_id` int DEFAULT NULL,
  `feature_group_statistics_id` int DEFAULT NULL,
  `feature_view_statistics_id` int DEFAULT NULL,
  `training_dataset_statistics_id` int DEFAULT NULL,
  `online_ingestion_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fsa_feature_view_fk` (`feature_view_id`),
  KEY `fs_act_td_fk` (`training_dataset_id`),
  KEY `fs_act_uid_fk` (`uid`),
  KEY `fs_act_exec_fk` (`execution_id`),
  KEY `fs_act_commit_fk` (`feature_group_id`,`commit_id`),
  KEY `fs_act_validationreport_fk` (`validation_report_id`),
  KEY `fs_act_expectationsuite_fk` (`expectation_suite_id`),
  KEY `fs_act_fg_stat_fk` (`feature_group_statistics_id`),
  KEY `fs_act_fv_stat_fk` (`feature_view_statistics_id`),
  KEY `fs_act_td_stat_fk` (`training_dataset_statistics_id`),
  KEY `fs_act_online_ingestion_fk` (`online_ingestion_id`),
  CONSTRAINT `fs_act_commit_fk` FOREIGN KEY (`feature_group_id`, `commit_id`) REFERENCES `feature_group_commit` (`feature_group_id`, `commit_id`) ON DELETE CASCADE,
  CONSTRAINT `fs_act_exec_fk` FOREIGN KEY (`execution_id`) REFERENCES `executions` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_act_expectationsuite_fk` FOREIGN KEY (`expectation_suite_id`) REFERENCES `expectation_suite` (`id`) ON DELETE SET NULL,
  CONSTRAINT `fs_act_fg_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_act_fg_stat_fk` FOREIGN KEY (`feature_group_statistics_id`) REFERENCES `feature_group_statistics` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_act_fv_stat_fk` FOREIGN KEY (`feature_view_statistics_id`) REFERENCES `feature_view_statistics` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_act_online_ingestion_fk` FOREIGN KEY (`online_ingestion_id`) REFERENCES `online_ingestion` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_act_td_fk` FOREIGN KEY (`training_dataset_id`) REFERENCES `training_dataset` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_act_td_stat_fk` FOREIGN KEY (`training_dataset_statistics_id`) REFERENCES `training_dataset_statistics` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_act_uid_fk` FOREIGN KEY (`uid`) REFERENCES `users` (`uid`) ON DELETE CASCADE,
  CONSTRAINT `fs_act_validationreport_fk` FOREIGN KEY (`validation_report_id`) REFERENCES `validation_report` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fsa_feature_view_fk` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_adls_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_adls_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `generation` int NOT NULL,
  `directory_id` varchar(40) COLLATE latin1_general_cs NOT NULL,
  `application_id` varchar(40) COLLATE latin1_general_cs NOT NULL,
  `account_name` varchar(30) COLLATE latin1_general_cs NOT NULL,
  `container_name` varchar(65) COLLATE latin1_general_cs DEFAULT NULL,
  `cred_secret_uid` int NOT NULL,
  `cred_secret_name` varchar(200) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  KEY `adls_cred_secret_fk` (`cred_secret_uid`,`cred_secret_name`),
  CONSTRAINT `adls_cred_secret_fk` FOREIGN KEY (`cred_secret_uid`, `cred_secret_name`) REFERENCES `secrets` (`uid`, `secret_name`) ON DELETE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_bigquery_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_bigquery_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `parent_project` varchar(1000) COLLATE latin1_general_cs NOT NULL,
  `dataset` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `query_table` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `query_project` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `materialization_dataset` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `arguments` varchar(2000) COLLATE latin1_general_cs DEFAULT NULL,
  `key_path` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_store_id` int NOT NULL,
  `name` varchar(150) COLLATE latin1_general_cs NOT NULL,
  `description` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `type` int NOT NULL,
  `jdbc_id` int DEFAULT NULL,
  `s3_id` int DEFAULT NULL,
  `hopsfs_id` int DEFAULT NULL,
  `redshift_id` int DEFAULT NULL,
  `adls_id` int DEFAULT NULL,
  `snowflake_id` int DEFAULT NULL,
  `kafka_id` int DEFAULT NULL,
  `gcs_id` int DEFAULT NULL,
  `bigquery_id` int DEFAULT NULL,
  `rds_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `fs_conn_name` (`name`,`feature_store_id`),
  KEY `fs_connector_featurestore_fk` (`feature_store_id`),
  KEY `fs_connector_jdbc_fk` (`jdbc_id`),
  KEY `fs_connector_s3_fk` (`s3_id`),
  KEY `fs_connector_hopsfs_fk` (`hopsfs_id`),
  KEY `fs_connector_redshift_fk` (`redshift_id`),
  KEY `fs_connector_adls_fk` (`adls_id`),
  KEY `fs_connector_snowflake_fk` (`snowflake_id`),
  KEY `fs_connector_kafka_fk` (`kafka_id`),
  KEY `fs_connector_gcs_fk` (`gcs_id`),
  KEY `fs_connector_bigquery_fk` (`bigquery_id`),
  KEY `fs_connector_rds_fk` (`rds_id`),
  CONSTRAINT `fs_connector_adls_fk` FOREIGN KEY (`adls_id`) REFERENCES `feature_store_adls_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_connector_bigquery_fk` FOREIGN KEY (`bigquery_id`) REFERENCES `feature_store_bigquery_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_connector_featurestore_fk` FOREIGN KEY (`feature_store_id`) REFERENCES `feature_store` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_connector_gcs_fk` FOREIGN KEY (`gcs_id`) REFERENCES `feature_store_gcs_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_connector_hopsfs_fk` FOREIGN KEY (`hopsfs_id`) REFERENCES `feature_store_hopsfs_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_connector_jdbc_fk` FOREIGN KEY (`jdbc_id`) REFERENCES `feature_store_jdbc_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_connector_kafka_fk` FOREIGN KEY (`kafka_id`) REFERENCES `feature_store_kafka_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_connector_rds_fk` FOREIGN KEY (`rds_id`) REFERENCES `feature_store_rds_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_connector_redshift_fk` FOREIGN KEY (`redshift_id`) REFERENCES `feature_store_redshift_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_connector_s3_fk` FOREIGN KEY (`s3_id`) REFERENCES `feature_store_s3_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_connector_snowflake_fk` FOREIGN KEY (`snowflake_id`) REFERENCES `feature_store_snowflake_connector` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_gcs_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_gcs_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `algorithm` varchar(10) COLLATE latin1_general_cs DEFAULT NULL,
  `bucket` varchar(1000) COLLATE latin1_general_cs NOT NULL,
  `encryption_secret_uid` int DEFAULT NULL,
  `encryption_secret_name` varchar(200) COLLATE latin1_general_cs DEFAULT NULL,
  `key_path` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_fs_storage_connector_gcs_idx` (`encryption_secret_uid`,`encryption_secret_name`),
  CONSTRAINT `fk_fs_storage_connector_gcs` FOREIGN KEY (`encryption_secret_uid`, `encryption_secret_name`) REFERENCES `secrets` (`uid`, `secret_name`) ON DELETE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_hopsfs_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_hopsfs_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `hopsfs_dataset` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `hopsfs_connector_dataset_fk` (`hopsfs_dataset`),
  CONSTRAINT `hopsfs_connector_dataset_fk` FOREIGN KEY (`hopsfs_dataset`) REFERENCES `dataset` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_jdbc_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_jdbc_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `connection_string` varchar(5000) COLLATE latin1_general_cs NOT NULL,
  `arguments` varchar(2000) COLLATE latin1_general_cs DEFAULT NULL,
  `secret_uid` int DEFAULT NULL,
  `secret_name` varchar(200) COLLATE latin1_general_cs DEFAULT NULL,
  `driver_path` varchar(2000) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_job`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_job` (
  `id` int NOT NULL AUTO_INCREMENT,
  `job_id` int NOT NULL,
  `training_dataset_id` int DEFAULT NULL,
  `feature_group_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fs_job_job_fk` (`job_id`),
  KEY `fs_job_td_fk` (`training_dataset_id`),
  KEY `fs_job_fg_fk` (`feature_group_id`),
  CONSTRAINT `fs_job_fg_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_job_job_fk` FOREIGN KEY (`job_id`) REFERENCES `jobs` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fs_job_td_fk` FOREIGN KEY (`training_dataset_id`) REFERENCES `training_dataset` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_kafka_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_kafka_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `bootstrap_servers` varchar(1000) COLLATE latin1_general_cs NOT NULL,
  `security_protocol` varchar(1000) COLLATE latin1_general_cs NOT NULL,
  `ssl_secret_uid` int DEFAULT NULL,
  `ssl_secret_name` varchar(200) COLLATE latin1_general_cs DEFAULT NULL,
  `ssl_endpoint_identification_algorithm` varchar(100) COLLATE latin1_general_cs DEFAULT NULL,
  `options` varchar(2000) COLLATE latin1_general_cs DEFAULT NULL,
  `truststore_path` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `keystore_path` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_fs_storage_connector_kafka_idx` (`ssl_secret_uid`,`ssl_secret_name`),
  CONSTRAINT `fk_fs_storage_connector_kafka` FOREIGN KEY (`ssl_secret_uid`, `ssl_secret_name`) REFERENCES `secrets` (`uid`, `secret_name`) ON DELETE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_keyword`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_keyword` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `feature_group_id` int DEFAULT NULL,
  `feature_view_id` int DEFAULT NULL,
  `training_dataset_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_fs_keyword_fg` (`feature_group_id`),
  KEY `fk_fs_keyword_fv` (`feature_view_id`),
  KEY `fk_fs_keyword_td` (`training_dataset_id`),
  CONSTRAINT `fk_fs_keyword_fg` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_fs_keyword_fv` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_fs_keyword_td` FOREIGN KEY (`training_dataset_id`) REFERENCES `training_dataset` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_rds_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_rds_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `host` varchar(128) COLLATE latin1_general_cs NOT NULL,
  `port` int DEFAULT NULL,
  `database_name` varchar(128) COLLATE latin1_general_cs DEFAULT NULL,
  `database_user` varchar(128) COLLATE latin1_general_cs DEFAULT NULL,
  `arguments` varchar(2000) COLLATE latin1_general_cs DEFAULT NULL,
  `database_pwd_secret_uid` int DEFAULT NULL,
  `database_pwd_secret_name` varchar(200) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_feature_store_rds_connector_idx` (`database_pwd_secret_uid`,`database_pwd_secret_name`),
  CONSTRAINT `fk_feature_store_rds_connector` FOREIGN KEY (`database_pwd_secret_uid`, `database_pwd_secret_name`) REFERENCES `secrets` (`uid`, `secret_name`) ON DELETE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_redshift_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_redshift_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `cluster_identifier` varchar(64) COLLATE latin1_general_cs NOT NULL,
  `database_driver` varchar(64) COLLATE latin1_general_cs NOT NULL,
  `database_endpoint` varchar(128) COLLATE latin1_general_cs DEFAULT NULL,
  `database_name` varchar(64) COLLATE latin1_general_cs DEFAULT NULL,
  `database_port` int DEFAULT NULL,
  `table_name` varchar(128) COLLATE latin1_general_cs DEFAULT NULL,
  `database_user_name` varchar(128) COLLATE latin1_general_cs DEFAULT NULL,
  `auto_create` tinyint(1) DEFAULT '0',
  `database_group` varchar(2048) COLLATE latin1_general_cs DEFAULT NULL,
  `iam_role` varchar(2048) COLLATE latin1_general_cs DEFAULT NULL,
  `arguments` varchar(2000) COLLATE latin1_general_cs DEFAULT NULL,
  `database_pwd_secret_uid` int DEFAULT NULL,
  `database_pwd_secret_name` varchar(200) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_feature_store_redshift_connector_2_idx` (`database_pwd_secret_uid`,`database_pwd_secret_name`),
  CONSTRAINT `fk_feature_store_redshift_connector_2` FOREIGN KEY (`database_pwd_secret_uid`, `database_pwd_secret_name`) REFERENCES `secrets` (`uid`, `secret_name`) ON DELETE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_s3_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_s3_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `bucket` varchar(5000) COLLATE latin1_general_cs NOT NULL,
  `iam_role` varchar(2048) COLLATE latin1_general_cs DEFAULT NULL,
  `server_encryption_algorithm` int DEFAULT NULL,
  `server_encryption_key` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `key_secret_uid` int DEFAULT NULL,
  `key_secret_name` varchar(200) COLLATE latin1_general_cs DEFAULT NULL,
  `arguments` varchar(2000) COLLATE latin1_general_cs DEFAULT NULL,
  `region` varchar(50) COLLATE latin1_general_cs DEFAULT NULL,
  `path` varchar(500) COLLATE latin1_general_cs DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `fk_feature_store_s3_connector_1_idx` (`key_secret_uid`,`key_secret_name`),
  CONSTRAINT `fk_feature_store_s3_connector_1` FOREIGN KEY (`key_secret_uid`, `key_secret_name`) REFERENCES `secrets` (`uid`, `secret_name`) ON DELETE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_snowflake_connector`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_snowflake_connector` (
  `id` int NOT NULL AUTO_INCREMENT,
  `url` varchar(3000) COLLATE latin1_general_cs NOT NULL,
  `database_user` varchar(128) COLLATE latin1_general_cs NOT NULL,
  `database_name` varchar(64) COLLATE latin1_general_cs NOT NULL,
  `database_schema` varchar(45) COLLATE latin1_general_cs DEFAULT NULL,
  `table_name` varchar(128) COLLATE latin1_general_cs DEFAULT NULL,
  `role` varchar(65) COLLATE latin1_general_cs DEFAULT NULL,
  `warehouse` varchar(128) COLLATE latin1_general_cs DEFAULT NULL,
  `arguments` varchar(8000) COLLATE latin1_general_cs DEFAULT NULL,
  `application` varchar(50) COLLATE latin1_general_cs DEFAULT NULL,
  `database_pwd_secret_uid` int DEFAULT NULL,
  `database_pwd_secret_name` varchar(200) COLLATE latin1_general_cs DEFAULT NULL,
  `oauth_token_secret_uid` int DEFAULT NULL,
  `oauth_token_secret_name` varchar(200) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_feature_store_snowflake_connector_2_idx` (`database_pwd_secret_uid`,`database_pwd_secret_name`),
  KEY `fk_feature_store_snowflake_connector_3_idx` (`oauth_token_secret_uid`,`oauth_token_secret_name`),
  CONSTRAINT `fk_feature_store_snowflake_connector_2` FOREIGN KEY (`database_pwd_secret_uid`, `database_pwd_secret_name`) REFERENCES `secrets` (`uid`, `secret_name`) ON DELETE RESTRICT,
  CONSTRAINT `fk_feature_store_snowflake_connector_3` FOREIGN KEY (`oauth_token_secret_uid`, `oauth_token_secret_name`) REFERENCES `secrets` (`uid`, `secret_name`) ON DELETE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_tag`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_tag` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `tag_schema` varchar(13000) COLLATE latin1_general_cs NOT NULL DEFAULT '{"type":"string"}',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name_UNIQUE` (`name`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_store_tag_value`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_store_tag_value` (
  `id` int NOT NULL AUTO_INCREMENT,
  `schema_id` int NOT NULL,
  `feature_group_id` int DEFAULT NULL,
  `feature_view_id` int DEFAULT NULL,
  `training_dataset_id` int DEFAULT NULL,
  `value` varchar(29000) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  KEY `fk_fs_tag_value_schema` (`schema_id`),
  KEY `fk_fs_tag_value_fg` (`feature_group_id`),
  KEY `fk_fs_tag_value_fv` (`feature_view_id`),
  KEY `fk_fs_tag_value_td` (`training_dataset_id`),
  CONSTRAINT `fk_fs_tag_value_fg` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_fs_tag_value_fv` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_fs_tag_value_schema` FOREIGN KEY (`schema_id`) REFERENCES `feature_store_tag` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_fs_tag_value_td` FOREIGN KEY (`training_dataset_id`) REFERENCES `training_dataset` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_view`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_view` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(63) COLLATE latin1_general_cs NOT NULL,
  `feature_store_id` int NOT NULL,
  `created` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `creator` int NOT NULL,
  `version` int NOT NULL,
  `description` varchar(10000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name_version` (`feature_store_id`,`name`,`version`),
  KEY `feature_store_id` (`feature_store_id`),
  KEY `creator` (`creator`),
  CONSTRAINT `fv_creator_fk` FOREIGN KEY (`creator`) REFERENCES `users` (`uid`),
  CONSTRAINT `fv_feature_store_id_fk` FOREIGN KEY (`feature_store_id`) REFERENCES `feature_store` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=9 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_view_alert`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_view_alert` (
  `id` int NOT NULL AUTO_INCREMENT,
  `status` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `type` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `severity` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `receiver` int NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `feature_view_id` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_feature_view_status` (`feature_view_id`,`status`),
  KEY `fk_fv_alert_1` (`receiver`),
  CONSTRAINT `fk_fv_alert_1` FOREIGN KEY (`receiver`) REFERENCES `alert_receiver` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_fv_alert_2` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_view_descriptive_statistics`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_view_descriptive_statistics` (
  `feature_view_statistics_id` int NOT NULL,
  `feature_descriptive_statistics_id` int NOT NULL,
  PRIMARY KEY (`feature_view_statistics_id`,`feature_descriptive_statistics_id`),
  KEY `fvds_fds_fk` (`feature_descriptive_statistics_id`),
  CONSTRAINT `fvds_fds_fk` FOREIGN KEY (`feature_descriptive_statistics_id`) REFERENCES `feature_descriptive_statistics` (`id`),
  CONSTRAINT `fvds_fvs_fk` FOREIGN KEY (`feature_view_statistics_id`) REFERENCES `feature_view_statistics` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_view_link`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_view_link` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_view_id` int NOT NULL,
  `parent_feature_group_id` int DEFAULT NULL,
  `parent_feature_store` varchar(100) COLLATE latin1_general_cs NOT NULL,
  `parent_feature_group_name` varchar(63) COLLATE latin1_general_cs NOT NULL,
  `parent_feature_group_version` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `link_unique` (`feature_view_id`,`parent_feature_group_id`),
  KEY `feature_view_id_fkc` (`feature_view_id`),
  KEY `feature_view_parent_id_fkc` (`parent_feature_group_id`),
  CONSTRAINT `feature_view_id_fkc` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE,
  CONSTRAINT `feature_view_parent_fkc` FOREIGN KEY (`parent_feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE SET NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_view_logging`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_view_logging` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_view_id` int DEFAULT NULL,
  `transformed_fg_id` int DEFAULT NULL,
  `untransformed_fg_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fvl_fv` (`feature_view_id`),
  KEY `fvl_transformed_fg` (`transformed_fg_id`),
  KEY `fvl_untransformed_fg` (`untransformed_fg_id`),
  CONSTRAINT `fvl_fv` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fvl_transformed_fg` FOREIGN KEY (`transformed_fg_id`) REFERENCES `feature_group` (`id`) ON DELETE SET NULL,
  CONSTRAINT `fvl_untransformed_fg` FOREIGN KEY (`untransformed_fg_id`) REFERENCES `feature_group` (`id`) ON DELETE SET NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_view_statistics`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_view_statistics` (
  `id` int NOT NULL AUTO_INCREMENT,
  `computation_time` datetime(3) NOT NULL,
  `feature_view_id` int NOT NULL,
  `row_percentage` decimal(15,2) NOT NULL DEFAULT '1.00',
  `window_start_commit_time` bigint NOT NULL DEFAULT '0',
  `window_end_commit_time` bigint NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `window_commit_times_row_perc_fk` (`feature_view_id`,`window_start_commit_time`,`window_end_commit_time`,`row_percentage`),
  KEY `feature_view_id` (`feature_view_id`),
  CONSTRAINT `fvs_fv_fk` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `feature_view_transformation_function`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `feature_view_transformation_function` (
  `id` int NOT NULL AUTO_INCREMENT,
  `transformation_function_id` int NOT NULL,
  `feature_view_id` int NOT NULL,
  `features` varchar(5004) COLLATE latin1_general_cs NOT NULL,
  `output_features` varchar(5004) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fvtf_fvi_fk` (`feature_view_id`),
  KEY `fvtf_tfi_fk` (`transformation_function_id`),
  CONSTRAINT `fvtf_fvi_fk` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fvtf_tfi_fk` FOREIGN KEY (`transformation_function_id`) REFERENCES `transformation_function` (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `files_to_remove`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `files_to_remove` (
  `execution_id` int NOT NULL,
  `filepath` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`execution_id`,`filepath`),
  CONSTRAINT `FK_361_376` FOREIGN KEY (`execution_id`) REFERENCES `executions` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `flyway_schema_history`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `flyway_schema_history` (
  `installed_rank` int NOT NULL,
  `version` varchar(50) DEFAULT NULL,
  `description` varchar(200) NOT NULL,
  `type` varchar(20) NOT NULL,
  `script` varchar(1000) NOT NULL,
  `checksum` int DEFAULT NULL,
  `installed_by` varchar(100) NOT NULL,
  `installed_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `execution_time` int NOT NULL,
  `success` tinyint(1) NOT NULL,
  PRIMARY KEY (`installed_rank`),
  KEY `flyway_schema_history_s_idx` (`success`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `git_commits`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `git_commits` (
  `id` int NOT NULL AUTO_INCREMENT,
  `repository` int NOT NULL,
  `branch` varchar(250) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `hash` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `message` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `committer_name` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `committer_email` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `date` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `repository_fk` (`repository`),
  CONSTRAINT `repository_fk` FOREIGN KEY (`repository`) REFERENCES `git_repositories` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=4119 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `git_executions`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `git_executions` (
  `id` int NOT NULL AUTO_INCREMENT,
  `submission_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `user` int NOT NULL,
  `repository` int NOT NULL,
  `execution_start` bigint DEFAULT NULL,
  `execution_stop` bigint DEFAULT NULL,
  `command_config` varchar(11000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `state` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `final_result_message` varchar(11000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `config_secret` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `hostname` varchar(128) COLLATE latin1_general_cs NOT NULL DEFAULT 'localhost',
  PRIMARY KEY (`id`),
  KEY `user` (`user`),
  KEY `git_exec_repo_fkc` (`repository`),
  CONSTRAINT `git_exec_repo_fkc` FOREIGN KEY (`repository`) REFERENCES `git_repositories` (`id`) ON DELETE CASCADE,
  CONSTRAINT `git_exec_usr_fkc` FOREIGN KEY (`user`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=8251 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `git_repositories`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `git_repositories` (
  `id` int NOT NULL AUTO_INCREMENT,
  `path` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `project` int NOT NULL,
  `provider` varchar(20) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `current_branch` varchar(250) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `current_commit` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `cid` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `creator` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `repository_path_constraint_unique` (`path`),
  KEY `project_fk` (`project`),
  CONSTRAINT `project_fk` FOREIGN KEY (`project`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=2061 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `git_repository_remotes`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `git_repository_remotes` (
  `id` int NOT NULL AUTO_INCREMENT,
  `repository` int NOT NULL,
  `remote_name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `remote_url` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  KEY `git_repository_fk` (`repository`),
  CONSTRAINT `git_repository_fk` FOREIGN KEY (`repository`) REFERENCES `git_repositories` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=6164 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `great_expectation`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `great_expectation` (
  `id` int NOT NULL AUTO_INCREMENT,
  `kwargs_template` varchar(1000) COLLATE latin1_general_cs NOT NULL,
  `expectation_type` varchar(150) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_great_expectation` (`expectation_type`)
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_command_execution`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_command_execution` (
  `id` int NOT NULL AUTO_INCREMENT,
  `execution_id` int NOT NULL,
  `command` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `submitted` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `src_path` varchar(1000) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `uq_execution_id` (`execution_id`),
  UNIQUE KEY `uq_src_path` (`src_path`),
  KEY `fk_hdfs_file_command_1_idx` (`execution_id`),
  CONSTRAINT `fk_hdfs_file_command_1` FOREIGN KEY (`execution_id`) REFERENCES `executions` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hopsworks_action`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hopsworks_action` (
  `id` int NOT NULL AUTO_INCREMENT,
  `parent_action_id` int DEFAULT NULL,
  `status` varchar(50) COLLATE latin1_general_cs NOT NULL,
  `name` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `task` mediumblob NOT NULL,
  `start_time` timestamp(3) NOT NULL DEFAULT CURRENT_TIMESTAMP(3),
  `end_time` timestamp(3) NULL DEFAULT NULL,
  `attempt_limit` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `hopsworks_action_parent_action_id_idx` (`parent_action_id`),
  CONSTRAINT `hopsworks_action_parent_action_fkc` FOREIGN KEY (`parent_action_id`) REFERENCES `hopsworks_action` (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hopsworks_action_attempt`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hopsworks_action_attempt` (
  `id` int NOT NULL AUTO_INCREMENT,
  `action_id` int NOT NULL,
  `message` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `start_time` timestamp(3) NOT NULL DEFAULT CURRENT_TIMESTAMP(3),
  `end_time` timestamp(3) NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `hopsworks_action_attempt_action_id_fkc` (`action_id`),
  CONSTRAINT `hopsworks_action_attempt_action_id_fkc` FOREIGN KEY (`action_id`) REFERENCES `hopsworks_action` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `invalid_jwt`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `invalid_jwt` (
  `jti` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `expiration_time` datetime NOT NULL,
  `renewable_for_sec` int NOT NULL,
  PRIMARY KEY (`jti`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `job_alert`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `job_alert` (
  `id` int NOT NULL AUTO_INCREMENT,
  `job_id` int NOT NULL,
  `status` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `type` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `severity` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `receiver` int NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `threshold` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_job_alert` (`job_id`,`status`),
  KEY `fk_job_alert_2_idx` (`job_id`),
  KEY `fk_job_alert_1_idx` (`receiver`),
  CONSTRAINT `fk_job_alert_1` FOREIGN KEY (`receiver`) REFERENCES `alert_receiver` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_job_alert_2` FOREIGN KEY (`job_id`) REFERENCES `jobs` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `job_schedule`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `job_schedule` (
  `id` int NOT NULL AUTO_INCREMENT,
  `job_id` int NOT NULL,
  `start_date_time` timestamp NOT NULL,
  `end_date_time` timestamp NULL DEFAULT NULL,
  `enabled` tinyint(1) NOT NULL,
  `cron_expression` varchar(500) COLLATE latin1_general_cs NOT NULL,
  `next_execution_date_time` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `job_id` (`job_id`),
  CONSTRAINT `fk_schedule_job` FOREIGN KEY (`job_id`) REFERENCES `jobs` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `jobs`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `jobs` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `creation_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `project_id` int NOT NULL,
  `creator` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `type` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `json_config` varchar(12500) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `environment_id` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name_project_idx` (`name`,`project_id`),
  KEY `project_id` (`project_id`),
  KEY `creator` (`creator`),
  KEY `creator_project_idx` (`creator`,`project_id`),
  KEY `creation_time_project_idx` (`creation_time`,`project_id`),
  KEY `type_project_id_idx` (`type`,`project_id`),
  KEY `job_environment_fk` (`environment_id`),
  CONSTRAINT `FK_262_353` FOREIGN KEY (`creator`) REFERENCES `users` (`email`),
  CONSTRAINT `FK_284_352` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE,
  CONSTRAINT `job_environment_fk` FOREIGN KEY (`environment_id`) REFERENCES `environment` (`id`) ON DELETE RESTRICT
) ENGINE=ndbcluster AUTO_INCREMENT=37 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `jupyter_project`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `jupyter_project` (
  `id` int NOT NULL AUTO_INCREMENT,
  `port` int NOT NULL,
  `uid` int NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `expires` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `no_limit` tinyint(1) DEFAULT '0',
  `token` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `secret` varchar(64) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `cid` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `project_id` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `project_user` (`project_id`,`uid`),
  KEY `project_id` (`project_id`),
  KEY `jp_uid_fk` (`uid`),
  CONSTRAINT `FK_284_526` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE,
  CONSTRAINT `jp_uid_fk` FOREIGN KEY (`uid`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `jupyter_ray_session`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `jupyter_ray_session` (
  `id` int NOT NULL AUTO_INCREMENT,
  `creation_time` bigint DEFAULT NULL,
  `jupyter_project_id` int NOT NULL,
  `application_id` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `kernel_id` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `ray_head_node_service` varchar(255) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `kernel_id_unique` (`kernel_id`),
  UNIQUE KEY `application_id_unique` (`application_id`),
  KEY `fk_ray_session_jupyter_project` (`jupyter_project_id`),
  CONSTRAINT `fk_ray_session_jupyter_project` FOREIGN KEY (`jupyter_project_id`) REFERENCES `jupyter_project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `jupyter_settings`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `jupyter_settings` (
  `project_id` int NOT NULL,
  `team_member` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `secret` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `advanced` tinyint(1) DEFAULT '0',
  `shutdown_level` int NOT NULL DEFAULT '6',
  `no_limit` tinyint(1) DEFAULT '0',
  `base_dir` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `job_config` varchar(11000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `docker_config` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `python_kernel` tinyint(1) DEFAULT '1',
  `environment_id` int NOT NULL,
  `ray_config` varchar(5000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`project_id`,`team_member`),
  KEY `team_member` (`team_member`),
  KEY `secret_idx` (`secret`),
  KEY `jupyter_environment_fk` (`environment_id`),
  CONSTRAINT `FK_262_309` FOREIGN KEY (`team_member`) REFERENCES `users` (`email`) ON DELETE CASCADE,
  CONSTRAINT `FK_284_308` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE,
  CONSTRAINT `jupyter_environment_fk` FOREIGN KEY (`environment_id`) REFERENCES `environment` (`id`) ON DELETE RESTRICT
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `jupyter_spark_session`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `jupyter_spark_session` (
  `id` int NOT NULL AUTO_INCREMENT,
  `jupyter_project_id` int NOT NULL,
  `application_id` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `kernel_id` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `port` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `kernel_id` (`kernel_id`),
  KEY `fk_jupyter_project` (`jupyter_project_id`),
  CONSTRAINT `fk_jupyter_project` FOREIGN KEY (`jupyter_project_id`) REFERENCES `jupyter_project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `jwt_signing_key`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `jwt_signing_key` (
  `id` int NOT NULL AUTO_INCREMENT,
  `secret` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `created_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `jwt_signing_key_name_UNIQUE` (`name`)
) ENGINE=ndbcluster AUTO_INCREMENT=1057 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `kube_label`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `kube_label` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(317) COLLATE latin1_general_cs NOT NULL,
  `value` varchar(63) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name_value_idx` (`name`,`value`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `kube_priority_class`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `kube_priority_class` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(253) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name_idx` (`name`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `kube_project_label`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `kube_project_label` (
  `id` int NOT NULL AUTO_INCREMENT,
  `label_id` int NOT NULL,
  `project_id` int DEFAULT NULL,
  `base` int NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `label_fkc` (`label_id`),
  KEY `label_project_fkc` (`project_id`),
  CONSTRAINT `label_fkc` FOREIGN KEY (`label_id`) REFERENCES `kube_label` (`id`) ON DELETE CASCADE,
  CONSTRAINT `label_project_fkc` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `kube_project_priority_class`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `kube_project_priority_class` (
  `id` int NOT NULL AUTO_INCREMENT,
  `priority_class_id` int NOT NULL,
  `project_id` int DEFAULT NULL,
  `base` int NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `priority_class_fkc` (`priority_class_id`),
  KEY `priority_class_project_fkc` (`project_id`),
  CONSTRAINT `priority_class_fkc` FOREIGN KEY (`priority_class_id`) REFERENCES `kube_priority_class` (`id`) ON DELETE CASCADE,
  CONSTRAINT `priority_class_project_fkc` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `kubernetes_ops`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `kubernetes_ops` (
  `id` int NOT NULL AUTO_INCREMENT,
  `criticality` varchar(50) COLLATE latin1_general_cs NOT NULL,
  `status` varchar(50) COLLATE latin1_general_cs DEFAULT 'New',
  `kind` varchar(100) COLLATE latin1_general_cs NOT NULL,
  `verb` varchar(100) COLLATE latin1_general_cs NOT NULL,
  `namespace` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `resource` text COLLATE latin1_general_cs NOT NULL,
  `created_at` datetime NOT NULL,
  PRIMARY KEY (`id`),
  KEY `status` (`status`),
  KEY `created_at` (`created_at`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `materialized_jwt`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `materialized_jwt` (
  `project_id` int NOT NULL,
  `user_id` int NOT NULL,
  `usage` tinyint NOT NULL,
  `token` varchar(500) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`project_id`,`user_id`,`usage`),
  KEY `jwt_material_user` (`user_id`),
  CONSTRAINT `jwt_material_project` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE,
  CONSTRAINT `jwt_material_user` FOREIGN KEY (`user_id`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `message`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `message` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_from` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `user_to` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `date_sent` datetime NOT NULL,
  `subject` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `preview` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `content` varchar(11000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `unread` tinyint(1) NOT NULL,
  `deleted` tinyint(1) NOT NULL,
  `path` varchar(600) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `reply_to_msg` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `user_from` (`user_from`),
  KEY `user_to` (`user_to`),
  KEY `reply_to_msg` (`reply_to_msg`),
  CONSTRAINT `FK_262_441` FOREIGN KEY (`user_from`) REFERENCES `users` (`email`) ON DELETE SET NULL,
  CONSTRAINT `FK_262_442` FOREIGN KEY (`user_to`) REFERENCES `users` (`email`) ON DELETE CASCADE,
  CONSTRAINT `FK_438_443` FOREIGN KEY (`reply_to_msg`) REFERENCES `message` (`id`) ON DELETE SET NULL
) ENGINE=ndbcluster AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `message_to_user`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `message_to_user` (
  `message` int NOT NULL,
  `user_email` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`message`,`user_email`),
  KEY `user_email` (`user_email`),
  CONSTRAINT `FK_262_458` FOREIGN KEY (`user_email`) REFERENCES `users` (`email`) ON DELETE CASCADE,
  CONSTRAINT `FK_438_457` FOREIGN KEY (`message`) REFERENCES `message` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `model`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `model` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `project_id` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `project_unique_name` (`name`,`project_id`),
  KEY `model_project_fk` (`project_id`),
  CONSTRAINT `model_project_fk` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `model_link`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `model_link` (
  `id` int NOT NULL AUTO_INCREMENT,
  `model_version_id` int NOT NULL,
  `parent_training_dataset_id` int DEFAULT NULL,
  `parent_feature_store` varchar(100) COLLATE latin1_general_cs NOT NULL,
  `parent_feature_view_name` varchar(63) COLLATE latin1_general_cs NOT NULL,
  `parent_feature_view_version` int NOT NULL,
  `parent_training_dataset_version` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `link_unique` (`model_version_id`,`parent_training_dataset_id`),
  KEY `model_version_id_fkc` (`model_version_id`),
  KEY `parent_training_dataset_id_fkc` (`parent_training_dataset_id`),
  CONSTRAINT `model_version_id_fkc` FOREIGN KEY (`model_version_id`) REFERENCES `model_version` (`id`) ON DELETE CASCADE,
  CONSTRAINT `training_dataset_parent_fkc` FOREIGN KEY (`parent_training_dataset_id`) REFERENCES `training_dataset` (`id`) ON DELETE SET NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `model_version`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `model_version` (
  `id` int NOT NULL AUTO_INCREMENT,
  `model_id` int NOT NULL,
  `version` int NOT NULL,
  `user_id` int NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `description` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `metrics` varchar(3000) COLLATE latin1_general_cs DEFAULT NULL,
  `program` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `framework` varchar(128) COLLATE latin1_general_cs DEFAULT NULL,
  `environment` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `model_version_key` (`model_id`,`version`),
  KEY `user_fk` (`user_id`),
  CONSTRAINT `model_fk` FOREIGN KEY (`model_id`) REFERENCES `model` (`id`) ON DELETE CASCADE,
  CONSTRAINT `user_fk` FOREIGN KEY (`user_id`) REFERENCES `users` (`uid`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `monitoring_window_config`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `monitoring_window_config` (
  `id` int NOT NULL AUTO_INCREMENT,
  `window_config_type` int NOT NULL,
  `training_dataset_version` int DEFAULT NULL,
  `time_offset` varchar(63) COLLATE latin1_general_cs DEFAULT NULL,
  `window_length` varchar(63) COLLATE latin1_general_cs DEFAULT NULL,
  `row_percentage` decimal(15,2) DEFAULT NULL,
  `specific_value` float DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `oauth_client`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `oauth_client` (
  `id` int NOT NULL AUTO_INCREMENT,
  `client_id` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `client_secret` varchar(2048) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `provider_logo_uri` varchar(2048) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `provider_uri` varchar(2048) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `provider_name` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `provider_display_name` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `authorisation_endpoint` varchar(1024) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `token_endpoint` varchar(1024) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `userinfo_endpoint` varchar(1024) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `end_session_endpoint` varchar(1024) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `logout_redirect_param` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `jwks_uri` varchar(1024) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `provider_metadata_endpoint_supported` tinyint(1) NOT NULL DEFAULT '0',
  `offline_access` tinyint(1) NOT NULL DEFAULT '0',
  `code_challenge` tinyint(1) NOT NULL DEFAULT '0',
  `code_challenge_method` varchar(16) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `verify_email` tinyint(1) NOT NULL DEFAULT '0',
  `given_name_claim` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT 'given_name',
  `family_name_claim` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT 'family_name',
  `email_claim` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT 'email',
  `group_claim` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `client_id_UNIQUE` (`client_id`),
  UNIQUE KEY `provider_name_UNIQUE` (`provider_name`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `oauth_login_state`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `oauth_login_state` (
  `id` int NOT NULL AUTO_INCREMENT,
  `state` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `session_id` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `client_id` varchar(256) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `login_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `id_token` varchar(8000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `access_token` varchar(8000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `refresh_token` varchar(8000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `nonce` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `scopes` varchar(2048) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `code_challenge` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `redirect_uri` varchar(1024) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `login_state_UNIQUE` (`state`),
  KEY `fk_oauth_login_state_client` (`client_id`),
  CONSTRAINT `fk_oauth_login_state_client` FOREIGN KEY (`client_id`) REFERENCES `oauth_client` (`client_id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `oauth_token`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `oauth_token` (
  `id` int NOT NULL AUTO_INCREMENT,
  `user_id` int NOT NULL,
  `id_token` varchar(8000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `access_token` varchar(8000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `refresh_token` varchar(8000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `login_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `login_state_UNIQUE` (`user_id`),
  KEY `fk_oauth_token_user` (`user_id`),
  CONSTRAINT `fk_oauth_token_user` FOREIGN KEY (`user_id`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `on_demand_feature`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `on_demand_feature` (
  `id` int NOT NULL AUTO_INCREMENT,
  `on_demand_feature_group_id` int DEFAULT NULL,
  `name` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `primary_column` tinyint(1) NOT NULL DEFAULT '0',
  `description` varchar(10000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `type` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `idx` int NOT NULL DEFAULT '0',
  `default_value` varchar(400) COLLATE latin1_general_cs DEFAULT NULL,
  `foreign_column` tinyint(1) DEFAULT '0',
  `column_name` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `on_demand_feature_group_fk` (`on_demand_feature_group_id`),
  CONSTRAINT `on_demand_feature_group_fk1` FOREIGN KEY (`on_demand_feature_group_id`) REFERENCES `on_demand_feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `on_demand_feature_group`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `on_demand_feature_group` (
  `id` int NOT NULL AUTO_INCREMENT,
  `data_format` varchar(10) COLLATE latin1_general_cs DEFAULT NULL,
  `spine` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `on_demand_option`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `on_demand_option` (
  `id` int NOT NULL AUTO_INCREMENT,
  `on_demand_feature_group_id` int DEFAULT NULL,
  `name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `value` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  KEY `on_demand_option_key` (`on_demand_feature_group_id`),
  CONSTRAINT `on_demand_option_fk` FOREIGN KEY (`on_demand_feature_group_id`) REFERENCES `on_demand_feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `online_ingestion`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `online_ingestion` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_group_id` int DEFAULT NULL,
  `num_entries` bigint DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `oi_feature_group_fk` (`feature_group_id`),
  CONSTRAINT `oi_feature_group_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `ops_log`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `ops_log` (
  `id` int NOT NULL AUTO_INCREMENT,
  `op_id` int NOT NULL,
  `op_on` tinyint(1) NOT NULL,
  `op_type` tinyint(1) NOT NULL,
  `project_id` int NOT NULL,
  `dataset_id` bigint NOT NULL,
  `inode_id` bigint NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster AUTO_INCREMENT=1332 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `pki_certificate`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `pki_certificate` (
  `ca` tinyint NOT NULL,
  `serial_number` bigint NOT NULL,
  `status` tinyint NOT NULL,
  `subject` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `certificate` varbinary(10000) DEFAULT NULL,
  `not_before` datetime NOT NULL,
  `not_after` datetime NOT NULL,
  PRIMARY KEY (`status`,`subject`) USING HASH,
  KEY `sn_index` (`serial_number`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `pki_crl`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `pki_crl` (
  `type` varchar(20) COLLATE latin1_general_cs NOT NULL,
  `crl` mediumblob NOT NULL,
  PRIMARY KEY (`type`) USING HASH
) /*!50100 TABLESPACE `ts_1` STORAGE DISK */ ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `pki_key`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `pki_key` (
  `owner` varchar(100) COLLATE latin1_general_cs NOT NULL,
  `type` tinyint NOT NULL,
  `key` varbinary(8192) NOT NULL,
  PRIMARY KEY (`owner`,`type`) USING HASH
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `pki_serial_number`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `pki_serial_number` (
  `type` varchar(20) COLLATE latin1_general_cs NOT NULL,
  `number` bigint NOT NULL,
  PRIMARY KEY (`type`) USING HASH
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `project`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `project` (
  `id` int NOT NULL AUTO_INCREMENT,
  `projectname` varchar(100) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `username` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `description` varchar(2000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `payment_type` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT 'PREPAID',
  `last_quota_update` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `kafka_max_num_topics` int NOT NULL DEFAULT '100',
  `topic_name` varchar(255) COLLATE latin1_general_cs DEFAULT NULL,
  `creation_status` tinyint(1) NOT NULL DEFAULT '0',
  `online_feature_store_available` tinyint(1) NOT NULL DEFAULT '1',
  `namespace` varchar(63) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `projectname` (`projectname`),
  KEY `user_idx` (`username`),
  KEY `namespace_idx` (`namespace`),
  CONSTRAINT `FK_262_290` FOREIGN KEY (`username`) REFERENCES `users` (`email`)
) ENGINE=ndbcluster AUTO_INCREMENT=1143 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `project_service_alert`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `project_service_alert` (
  `id` int NOT NULL AUTO_INCREMENT,
  `project_id` int NOT NULL,
  `service` varchar(32) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `status` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `type` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `severity` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `receiver` int NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `threshold` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `unique_project_service_alert` (`project_id`,`status`),
  KEY `fk_project_service_2_idx` (`project_id`),
  KEY `fk_project_service_alert_1_idx` (`receiver`),
  CONSTRAINT `fk_project_service_alert_1` FOREIGN KEY (`receiver`) REFERENCES `alert_receiver` (`id`) ON DELETE CASCADE,
  CONSTRAINT `fk_project_service_alert_2` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `project_services`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `project_services` (
  `project_id` int NOT NULL,
  `service` varchar(32) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`project_id`,`service`),
  CONSTRAINT `FK_284_300` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `project_team`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `project_team` (
  `project_id` int NOT NULL,
  `team_member` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `team_role` varchar(32) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `added` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`project_id`,`team_member`),
  KEY `team_member` (`team_member`),
  CONSTRAINT `FK_262_304` FOREIGN KEY (`team_member`) REFERENCES `users` (`email`) ON DELETE CASCADE,
  CONSTRAINT `FK_284_303` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `project_topics`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `project_topics` (
  `topic_name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `project_id` int NOT NULL,
  `id` int NOT NULL AUTO_INCREMENT,
  `subject_id` int DEFAULT NULL,
  `num_partitions` int DEFAULT NULL,
  `num_replicas` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `topic_name_UNIQUE` (`topic_name`),
  UNIQUE KEY `topic_project` (`topic_name`,`project_id`),
  KEY `project_idx_proj_topics` (`project_id`),
  KEY `subject_idx` (`subject_id`),
  CONSTRAINT `project_idx_proj_topics` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE,
  CONSTRAINT `subject_idx` FOREIGN KEY (`subject_id`) REFERENCES `subjects` (`id`) ON DELETE SET NULL
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `python_library`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `python_library` (
  `id` int NOT NULL AUTO_INCREMENT,
  `dependency` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `version` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `repo_url` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `preinstalled` tinyint(1) DEFAULT '0',
  `install_type` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `dependency` (`dependency`,`version`,`install_type`,`repo_url`)
) ENGINE=ndbcluster AUTO_INCREMENT=1055 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `remote_group_project_mapping`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `remote_group_project_mapping` (
  `id` int NOT NULL AUTO_INCREMENT,
  `remote_group` varchar(256) COLLATE latin1_general_cs NOT NULL,
  `project` int NOT NULL,
  `project_role` varchar(32) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `index3` (`remote_group`,`project`),
  KEY `fk_remote_group_project_mapping_1_idx` (`project`),
  CONSTRAINT `fk_remote_group_project_mapping_1` FOREIGN KEY (`project`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `remote_material_references`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `remote_material_references` (
  `username` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `path` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `references` int NOT NULL DEFAULT '0',
  `lock` int NOT NULL DEFAULT '0',
  `lock_id` varchar(30) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT '',
  PRIMARY KEY (`username`,`path`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `remote_user`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `remote_user` (
  `id` int NOT NULL AUTO_INCREMENT,
  `type` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `status` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT '0',
  `auth_key` varchar(64) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `uuid` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `uid` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `uuid_UNIQUE` (`uuid`),
  UNIQUE KEY `uid_UNIQUE` (`uid`),
  CONSTRAINT `FK_257_557` FOREIGN KEY (`uid`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `roles_audit`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `roles_audit` (
  `log_id` bigint NOT NULL AUTO_INCREMENT,
  `target` int NOT NULL,
  `initiator` int NOT NULL,
  `action` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `action_timestamp` timestamp NULL DEFAULT NULL,
  `message` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `ip` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `outcome` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `useragent` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`log_id`),
  KEY `initiator` (`initiator`),
  KEY `target` (`target`),
  CONSTRAINT `FK_257_280` FOREIGN KEY (`initiator`) REFERENCES `users` (`uid`),
  CONSTRAINT `FK_257_281` FOREIGN KEY (`target`) REFERENCES `users` (`uid`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `rstudio_interpreter`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `rstudio_interpreter` (
  `port` int NOT NULL,
  `name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_accessed` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`port`,`name`),
  CONSTRAINT `FK_575_582` FOREIGN KEY (`port`) REFERENCES `rstudio_project` (`port`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `rstudio_project`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `rstudio_project` (
  `port` int NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `last_accessed` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `host_ip` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `token` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `secret` varchar(64) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `pid` bigint NOT NULL,
  `project_id` int NOT NULL,
  PRIMARY KEY (`port`),
  KEY `project_id` (`project_id`),
  CONSTRAINT `FK_284_578` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `rstudio_settings`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `rstudio_settings` (
  `project_id` int NOT NULL,
  `team_member` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `num_tf_ps` int DEFAULT '1',
  `num_tf_gpus` int DEFAULT '0',
  `num_mpi_np` int DEFAULT '1',
  `appmaster_cores` int DEFAULT '1',
  `appmaster_memory` int DEFAULT '1024',
  `num_executors` int DEFAULT '1',
  `num_executor_cores` int DEFAULT '1',
  `executor_memory` int DEFAULT '1024',
  `dynamic_initial_executors` int DEFAULT '1',
  `dynamic_min_executors` int DEFAULT '1',
  `dynamic_max_executors` int DEFAULT '1',
  `secret` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `log_level` varchar(32) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT 'INFO',
  `mode` varchar(32) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `umask` varchar(32) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT '022',
  `advanced` tinyint(1) DEFAULT '0',
  `archives` varchar(1500) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT '',
  `jars` varchar(1500) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT '',
  `files` varchar(1500) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT '',
  `py_files` varchar(1500) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT '',
  `spark_params` varchar(6500) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT '',
  `shutdown_level` int NOT NULL DEFAULT '6',
  PRIMARY KEY (`project_id`,`team_member`),
  KEY `team_member` (`team_member`),
  KEY `secret_idx` (`secret`),
  CONSTRAINT `RS_FK_PROJS` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE,
  CONSTRAINT `RS_FK_USERS` FOREIGN KEY (`team_member`) REFERENCES `users` (`email`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `schemas`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `schemas` (
  `id` int NOT NULL AUTO_INCREMENT,
  `schema` mediumtext CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `project_id` int NOT NULL,
  PRIMARY KEY (`id`),
  KEY `project_idx_schemas` (`project_id`)
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `secrets`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `secrets` (
  `uid` int NOT NULL,
  `secret_name` varchar(200) COLLATE latin1_general_cs NOT NULL,
  `secret` varbinary(10000) NOT NULL,
  `added_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `visibility` tinyint NOT NULL,
  `pid_scope` int DEFAULT NULL,
  PRIMARY KEY (`uid`,`secret_name`),
  CONSTRAINT `secrets_fk_1` FOREIGN KEY (`uid`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `serving`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `serving` (
  `id` int NOT NULL AUTO_INCREMENT,
  `local_port` int DEFAULT NULL,
  `cid` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `project_id` int NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `description` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `model_path` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `artifact_version` int DEFAULT NULL,
  `predictor` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `transformer` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `model_name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `model_version` int DEFAULT NULL,
  `model_framework` int DEFAULT NULL,
  `local_dir` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `batching_configuration` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `optimized` tinyint NOT NULL DEFAULT '0',
  `instances` int NOT NULL DEFAULT '0',
  `transformer_instances` int DEFAULT NULL,
  `creator` int DEFAULT NULL,
  `lock_ip` varchar(15) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `lock_timestamp` bigint DEFAULT NULL,
  `kafka_topic_id` int DEFAULT NULL,
  `inference_logging` int DEFAULT NULL,
  `model_server` int NOT NULL DEFAULT '0',
  `serving_tool` int NOT NULL DEFAULT '0',
  `deployed` timestamp NULL DEFAULT NULL,
  `deployed_by` int DEFAULT NULL,
  `revision` varchar(8) COLLATE latin1_general_cs DEFAULT NULL,
  `predictor_resources` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `transformer_resources` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `api_protocol` tinyint(1) NOT NULL DEFAULT '0',
  `environment_id` int DEFAULT NULL,
  `scheduling_config` varchar(2000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `config_file` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `serving_runtime` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `Serving_Constraint` (`project_id`,`name`),
  KEY `user_fk` (`creator`),
  KEY `deployed_by_fk` (`deployed_by`),
  KEY `kafka_fk` (`kafka_topic_id`),
  KEY `name_k` (`name`),
  KEY `serving_environment_fk` (`environment_id`),
  CONSTRAINT `deployed_by_fk_serving` FOREIGN KEY (`deployed_by`) REFERENCES `users` (`uid`) ON DELETE CASCADE,
  CONSTRAINT `FK_284_315` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE,
  CONSTRAINT `kafka_fk` FOREIGN KEY (`kafka_topic_id`) REFERENCES `project_topics` (`id`) ON DELETE SET NULL,
  CONSTRAINT `serving_environment_fk` FOREIGN KEY (`environment_id`) REFERENCES `environment` (`id`) ON DELETE SET NULL,
  CONSTRAINT `user_fk_serving` FOREIGN KEY (`creator`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `serving_key`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `serving_key` (
  `id` int NOT NULL AUTO_INCREMENT,
  `prefix` varchar(63) COLLATE latin1_general_cs DEFAULT '',
  `feature_name` varchar(1000) COLLATE latin1_general_cs NOT NULL,
  `join_on` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `join_index` int NOT NULL,
  `feature_group_id` int NOT NULL,
  `required` tinyint(1) NOT NULL DEFAULT '0',
  `feature_view_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `feature_view_id` (`feature_view_id`),
  KEY `feature_group_id` (`feature_group_id`),
  CONSTRAINT `feature_group_serving_key_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `feature_view_serving_key_fk` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `statistic_columns`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `statistic_columns` (
  `id` int NOT NULL AUTO_INCREMENT,
  `statistics_config_id` int DEFAULT NULL,
  `name` varchar(500) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `statistics_config_id` (`statistics_config_id`),
  CONSTRAINT `statistics_config_fk` FOREIGN KEY (`statistics_config_id`) REFERENCES `statistics_config` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `statistics_comparison_config`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `statistics_comparison_config` (
  `id` int NOT NULL AUTO_INCREMENT,
  `strict` tinyint(1) DEFAULT '0',
  `relative` tinyint(1) DEFAULT '0',
  `threshold` float DEFAULT NULL,
  `metric` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `statistics_config`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `statistics_config` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_group_id` int DEFAULT NULL,
  `training_dataset_id` int DEFAULT NULL,
  `descriptive` tinyint(1) NOT NULL DEFAULT '1',
  `correlations` tinyint(1) NOT NULL DEFAULT '1',
  `histograms` tinyint(1) NOT NULL DEFAULT '1',
  `exact_uniqueness` tinyint(1) NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `feature_group_id` (`feature_group_id`),
  KEY `training_dataset_id` (`training_dataset_id`),
  CONSTRAINT `fg_statistics_config_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `td_statistics_config_fk` FOREIGN KEY (`training_dataset_id`) REFERENCES `training_dataset` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `stream_feature_group`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `stream_feature_group` (
  `id` int NOT NULL AUTO_INCREMENT,
  `timetravel_format` int NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `subjects`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `subjects` (
  `id` int NOT NULL AUTO_INCREMENT,
  `subject` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `version` int NOT NULL,
  `schema_id` int NOT NULL,
  `project_id` int NOT NULL,
  `created_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  UNIQUE KEY `subjects__constraint_key` (`subject`,`version`,`project_id`),
  KEY `project_id_idx` (`project_id`),
  KEY `created_on_idx` (`created_on`),
  KEY `schema_id_idx` (`schema_id`),
  CONSTRAINT `project_idx_subjects` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE,
  CONSTRAINT `schema_id_idx` FOREIGN KEY (`schema_id`) REFERENCES `schemas` (`id`)
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `subjects_compatibility`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `subjects_compatibility` (
  `id` int NOT NULL AUTO_INCREMENT,
  `subject` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `compatibility` enum('BACKWARD','BACKWARD_TRANSITIVE','FORWARD','FORWARD_TRANSITIVE','FULL','FULL_TRANSITIVE','NONE') COLLATE latin1_general_cs NOT NULL DEFAULT 'BACKWARD',
  `project_id` int NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `subjects_compatibility__constraint_key` (`subject`,`project_id`),
  KEY `project_idx_sub_comp` (`project_id`),
  CONSTRAINT `project_idx_sub_comp` FOREIGN KEY (`project_id`) REFERENCES `project` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `test_dataset_descriptive_statistics`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `test_dataset_descriptive_statistics` (
  `training_dataset_statistics_id` int NOT NULL,
  `feature_descriptive_statistics_id` int NOT NULL,
  PRIMARY KEY (`training_dataset_statistics_id`,`feature_descriptive_statistics_id`),
  KEY `tsds_fds_fk` (`feature_descriptive_statistics_id`),
  CONSTRAINT `tsds_fds_fk` FOREIGN KEY (`feature_descriptive_statistics_id`) REFERENCES `feature_descriptive_statistics` (`id`),
  CONSTRAINT `tsds_tds_fk` FOREIGN KEY (`training_dataset_statistics_id`) REFERENCES `training_dataset_statistics` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `training_dataset`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `training_dataset` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(63) COLLATE latin1_general_cs NOT NULL,
  `feature_store_id` int NOT NULL,
  `created` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `creator` int NOT NULL,
  `version` int NOT NULL,
  `data_format` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `description` varchar(10000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `hopsfs_training_dataset_id` int DEFAULT NULL,
  `external_training_dataset_id` int DEFAULT NULL,
  `training_dataset_type` int NOT NULL DEFAULT '0',
  `seed` bigint DEFAULT NULL,
  `query` tinyint(1) NOT NULL DEFAULT '0',
  `coalesce` tinyint(1) NOT NULL DEFAULT '0',
  `train_split` varchar(63) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `feature_view_id` int DEFAULT NULL,
  `start_time` timestamp NULL DEFAULT NULL,
  `end_time` timestamp NULL DEFAULT NULL,
  `sample_ratio` float DEFAULT NULL,
  `connector_id` int DEFAULT NULL,
  `connector_path` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  `tag_path` varchar(1000) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name_version` (`feature_store_id`,`feature_view_id`,`name`,`version`),
  KEY `feature_store_id` (`feature_store_id`),
  KEY `creator` (`creator`),
  KEY `td_feature_view_fk` (`feature_view_id`),
  KEY `td_conn_fk` (`connector_id`),
  CONSTRAINT `FK_1012_877` FOREIGN KEY (`creator`) REFERENCES `users` (`uid`),
  CONSTRAINT `FK_656_817` FOREIGN KEY (`feature_store_id`) REFERENCES `feature_store` (`id`) ON DELETE CASCADE,
  CONSTRAINT `td_conn_fk` FOREIGN KEY (`connector_id`) REFERENCES `feature_store_connector` (`id`) ON DELETE CASCADE,
  CONSTRAINT `td_feature_view_fk` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=9 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `training_dataset_descriptive_statistics`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `training_dataset_descriptive_statistics` (
  `training_dataset_statistics_id` int NOT NULL,
  `feature_descriptive_statistics_id` int NOT NULL,
  PRIMARY KEY (`training_dataset_statistics_id`,`feature_descriptive_statistics_id`),
  KEY `tdds_fds_fk` (`feature_descriptive_statistics_id`),
  CONSTRAINT `tdds_fds_fk` FOREIGN KEY (`feature_descriptive_statistics_id`) REFERENCES `feature_descriptive_statistics` (`id`),
  CONSTRAINT `tdds_tds_fk` FOREIGN KEY (`training_dataset_statistics_id`) REFERENCES `training_dataset_statistics` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `training_dataset_feature`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `training_dataset_feature` (
  `id` int NOT NULL AUTO_INCREMENT,
  `training_dataset` int DEFAULT NULL,
  `feature_group` int DEFAULT NULL,
  `name` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `type` varchar(1000) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `td_join` int DEFAULT NULL,
  `idx` int DEFAULT NULL,
  `label` tinyint(1) NOT NULL DEFAULT '0',
  `inference_helper_column` tinyint(1) NOT NULL DEFAULT '0',
  `training_helper_column` tinyint(1) NOT NULL DEFAULT '0',
  `feature_view_id` int DEFAULT NULL,
  `on_demand_transformation` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `td_key` (`training_dataset`),
  KEY `fg_key` (`feature_group`),
  KEY `tdf_feature_view_fk` (`feature_view_id`),
  KEY `join_fk_tdf` (`td_join`),
  KEY `odtf_fk_fgtf` (`on_demand_transformation`),
  CONSTRAINT `fg_fk_tdf` FOREIGN KEY (`feature_group`) REFERENCES `feature_group` (`id`) ON DELETE SET NULL,
  CONSTRAINT `join_fk_tdf` FOREIGN KEY (`td_join`) REFERENCES `training_dataset_join` (`id`) ON DELETE SET NULL,
  CONSTRAINT `odtf_fk_fgtf` FOREIGN KEY (`on_demand_transformation`) REFERENCES `feature_group_transformation_functions` (`id`) ON DELETE CASCADE,
  CONSTRAINT `td_fk_tdf` FOREIGN KEY (`training_dataset`) REFERENCES `training_dataset` (`id`) ON DELETE CASCADE,
  CONSTRAINT `tdf_feature_view_fk` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `training_dataset_filter`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `training_dataset_filter` (
  `id` int NOT NULL AUTO_INCREMENT,
  `training_dataset_id` int DEFAULT NULL,
  `feature_view_id` int DEFAULT NULL,
  `type` varchar(63) COLLATE latin1_general_cs DEFAULT NULL,
  `path` varchar(63) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `tdf_training_dataset_fk` (`training_dataset_id`),
  KEY `tdfilter_feature_view_fk` (`feature_view_id`),
  CONSTRAINT `tdf_training_dataset_fk` FOREIGN KEY (`training_dataset_id`) REFERENCES `training_dataset` (`id`) ON DELETE CASCADE,
  CONSTRAINT `tdfilter_feature_view_fk` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `training_dataset_filter_condition`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `training_dataset_filter_condition` (
  `id` int NOT NULL AUTO_INCREMENT,
  `training_dataset_filter_id` int DEFAULT NULL,
  `feature_group_id` int DEFAULT NULL,
  `feature_name` varchar(63) COLLATE latin1_general_cs DEFAULT NULL,
  `filter_condition` varchar(128) COLLATE latin1_general_cs DEFAULT NULL,
  `filter_value` varchar(1024) COLLATE latin1_general_cs DEFAULT NULL,
  `filter_value_fg_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `tdfc_training_dataset_filter_fk` (`training_dataset_filter_id`),
  KEY `tdfc_feature_group_fk` (`feature_group_id`),
  CONSTRAINT `tdfc_feature_group_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE SET NULL,
  CONSTRAINT `tdfc_training_dataset_filter_fk` FOREIGN KEY (`training_dataset_filter_id`) REFERENCES `training_dataset_filter` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `training_dataset_join`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `training_dataset_join` (
  `id` int NOT NULL AUTO_INCREMENT,
  `training_dataset` int DEFAULT NULL,
  `feature_group` int DEFAULT NULL,
  `left_feature_group` int DEFAULT NULL,
  `feature_group_commit_id` bigint DEFAULT NULL,
  `type` tinyint NOT NULL DEFAULT '0',
  `idx` int NOT NULL DEFAULT '0',
  `parent_idx` int NOT NULL DEFAULT '0',
  `prefix` varchar(63) COLLATE latin1_general_cs DEFAULT NULL,
  `feature_view_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `fg_key` (`feature_group`),
  KEY `tdj_feature_view_fk` (`feature_view_id`),
  KEY `td_fk_tdj` (`training_dataset`),
  CONSTRAINT `fg_left` FOREIGN KEY (`feature_group`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE,
  CONSTRAINT `td_fk_tdj` FOREIGN KEY (`training_dataset`) REFERENCES `training_dataset` (`id`) ON DELETE CASCADE,
  CONSTRAINT `tdj_feature_view_fk` FOREIGN KEY (`feature_view_id`) REFERENCES `feature_view` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `training_dataset_join_condition`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `training_dataset_join_condition` (
  `id` int NOT NULL AUTO_INCREMENT,
  `td_join` int NOT NULL,
  `left_feature` varchar(1000) COLLATE latin1_general_cs NOT NULL DEFAULT '',
  `right_feature` varchar(1000) COLLATE latin1_general_cs NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `join_key` (`td_join`),
  CONSTRAINT `join_fk_tdjc` FOREIGN KEY (`td_join`) REFERENCES `training_dataset_join` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `training_dataset_split`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `training_dataset_split` (
  `id` int NOT NULL AUTO_INCREMENT,
  `training_dataset_id` int NOT NULL,
  `name` varchar(63) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `percentage` float DEFAULT NULL,
  `split_type` varchar(40) COLLATE latin1_general_cs DEFAULT NULL,
  `start_time` timestamp NULL DEFAULT NULL,
  `end_Time` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `dataset_id_split_name` (`training_dataset_id`,`name`),
  KEY `training_dataset_id` (`training_dataset_id`),
  CONSTRAINT `training_dataset_fk` FOREIGN KEY (`training_dataset_id`) REFERENCES `training_dataset` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `training_dataset_statistics`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `training_dataset_statistics` (
  `id` int NOT NULL AUTO_INCREMENT,
  `computation_time` datetime(3) NOT NULL,
  `training_dataset_id` int NOT NULL,
  `before_transformation` tinyint(1) DEFAULT '0',
  `row_percentage` decimal(6,5) NOT NULL DEFAULT '1.00000',
  PRIMARY KEY (`id`),
  UNIQUE KEY `tr_ids_for_trans_row_perc_fk` (`training_dataset_id`,`before_transformation`,`row_percentage`),
  KEY `training_dataset_id` (`training_dataset_id`),
  CONSTRAINT `tds_td_fk` FOREIGN KEY (`training_dataset_id`) REFERENCES `training_dataset` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `transformation_function`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `transformation_function` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `output_type` varchar(5004) COLLATE latin1_general_cs DEFAULT NULL,
  `version` int NOT NULL,
  `feature_store_id` int NOT NULL,
  `created` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `creator` int NOT NULL,
  `save_type` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `transformation_function_argument_names` varchar(5004) COLLATE latin1_general_cs NOT NULL,
  `dropped_argument_names` varchar(5004) COLLATE latin1_general_cs DEFAULT NULL,
  `statistics_argument_names` varchar(5004) COLLATE latin1_general_cs DEFAULT NULL,
  `execution_mode` varchar(255) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `feature_store_fn_fk` (`feature_store_id`),
  KEY `creator_fn_fk` (`creator`),
  CONSTRAINT `creator_fn_fk` FOREIGN KEY (`creator`) REFERENCES `users` (`uid`),
  CONSTRAINT `feature_store_fn_fk` FOREIGN KEY (`feature_store_id`) REFERENCES `feature_store` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1025 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `triggered_alert`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `triggered_alert` (
  `id` int NOT NULL AUTO_INCREMENT,
  `submission_time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `execution_id` int DEFAULT NULL,
  `job_alert_id` int DEFAULT NULL,
  `project_service_alert_id` int DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `execution_id_fk` (`execution_id`),
  KEY `job_alert_id_fk` (`job_alert_id`),
  KEY `project_service_alert_id_fk` (`project_service_alert_id`),
  CONSTRAINT `execution_id_fk` FOREIGN KEY (`execution_id`) REFERENCES `executions` (`id`) ON DELETE CASCADE,
  CONSTRAINT `job_alert_id_fk` FOREIGN KEY (`job_alert_id`) REFERENCES `job_alert` (`id`) ON DELETE CASCADE,
  CONSTRAINT `project_service_alert_id_fk` FOREIGN KEY (`project_service_alert_id`) REFERENCES `project_service_alert` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `tutorial`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `tutorial` (
  `id` int NOT NULL AUTO_INCREMENT,
  `idx` int NOT NULL,
  `name` varchar(100) COLLATE latin1_general_cs NOT NULL,
  `github_path` varchar(200) COLLATE latin1_general_cs NOT NULL,
  `description` varchar(200) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `user_certs`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `user_certs` (
  `projectname` varchar(100) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `username` varchar(10) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `user_key` varbinary(7000) DEFAULT NULL,
  `user_cert` varbinary(3000) DEFAULT NULL,
  `user_key_pwd` varchar(200) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`projectname`,`username`),
  KEY `username` (`username`),
  CONSTRAINT `FK_260_465` FOREIGN KEY (`username`) REFERENCES `users` (`username`) ON DELETE CASCADE,
  CONSTRAINT `FK_287_464` FOREIGN KEY (`projectname`) REFERENCES `project` (`projectname`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `user_group`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `user_group` (
  `uid` int NOT NULL,
  `gid` int NOT NULL,
  PRIMARY KEY (`uid`,`gid`),
  KEY `gid` (`gid`),
  CONSTRAINT `FK_255_269` FOREIGN KEY (`gid`) REFERENCES `bbc_group` (`gid`),
  CONSTRAINT `FK_257_268` FOREIGN KEY (`uid`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `userlogins`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `userlogins` (
  `login_id` bigint NOT NULL AUTO_INCREMENT,
  `ip` varchar(45) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `useragent` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `action` varchar(80) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `outcome` varchar(20) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `uid` int NOT NULL,
  `login_date` timestamp NULL DEFAULT NULL,
  PRIMARY KEY (`login_id`),
  KEY `login_date` (`login_date`),
  KEY `uid` (`uid`),
  CONSTRAINT `FK_257_345` FOREIGN KEY (`uid`) REFERENCES `users` (`uid`) ON DELETE CASCADE
) ENGINE=ndbcluster AUTO_INCREMENT=1340 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `users`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `users` (
  `uid` int NOT NULL AUTO_INCREMENT,
  `username` varchar(10) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `password` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `email` varchar(150) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `fname` varchar(30) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL,
  `lname` varchar(30) CHARACTER SET utf8mb4 COLLATE utf8mb4_0900_ai_ci DEFAULT NULL,
  `activated` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `title` varchar(10) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT '-',
  `false_login` int NOT NULL DEFAULT '-1',
  `status` int NOT NULL DEFAULT '-1',
  `isonline` int NOT NULL DEFAULT '-1',
  `secret` varchar(20) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `validation_key` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT NULL,
  `validation_key_updated` timestamp NULL DEFAULT NULL,
  `validation_key_type` varchar(20) COLLATE latin1_general_cs DEFAULT NULL,
  `mode` int NOT NULL DEFAULT '0',
  `password_changed` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `notes` varchar(500) CHARACTER SET latin1 COLLATE latin1_general_cs DEFAULT '-',
  `max_num_projects` int NOT NULL,
  `num_active_projects` int NOT NULL DEFAULT '0',
  `two_factor` tinyint(1) NOT NULL DEFAULT '1',
  `tours_state` tinyint(1) NOT NULL DEFAULT '0',
  `salt` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT '',
  `last_visited_at` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`uid`),
  UNIQUE KEY `username` (`username`),
  UNIQUE KEY `email` (`email`)
) ENGINE=ndbcluster AUTO_INCREMENT=11202 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `val_dataset_descriptive_statistics`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `val_dataset_descriptive_statistics` (
  `training_dataset_statistics_id` int NOT NULL,
  `feature_descriptive_statistics_id` int NOT NULL,
  PRIMARY KEY (`training_dataset_statistics_id`,`feature_descriptive_statistics_id`),
  KEY `vlds_fds_fk` (`feature_descriptive_statistics_id`),
  CONSTRAINT `vlds_fds_fk` FOREIGN KEY (`feature_descriptive_statistics_id`) REFERENCES `feature_descriptive_statistics` (`id`),
  CONSTRAINT `vlds_tds_fk` FOREIGN KEY (`training_dataset_statistics_id`) REFERENCES `training_dataset_statistics` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `validation_report`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `validation_report` (
  `id` int NOT NULL AUTO_INCREMENT,
  `feature_group_id` int NOT NULL,
  `success` tinyint(1) NOT NULL,
  `validation_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `evaluation_parameters` varchar(1000) COLLATE latin1_general_cs DEFAULT '{}',
  `meta` varchar(2000) COLLATE latin1_general_cs DEFAULT '{}',
  `statistics` varchar(1000) COLLATE latin1_general_cs NOT NULL,
  `file_name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `ingestion_result` varchar(11) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`id`),
  KEY `feature_group_report_fk` (`feature_group_id`),
  CONSTRAINT `feature_group_report_fk` FOREIGN KEY (`feature_group_id`) REFERENCES `feature_group` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `validation_result`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `validation_result` (
  `id` int NOT NULL AUTO_INCREMENT,
  `validation_report_id` int NOT NULL,
  `expectation_id` int NOT NULL,
  `success` tinyint(1) NOT NULL,
  `result` varchar(1000) COLLATE latin1_general_cs NOT NULL,
  `meta` varchar(1000) COLLATE latin1_general_cs DEFAULT '{}',
  `validation_time` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
  `ingestion_result` varchar(11) COLLATE latin1_general_cs NOT NULL,
  `expectation_config` varchar(2150) COLLATE latin1_general_cs NOT NULL,
  `exception_info` varchar(1000) COLLATE latin1_general_cs DEFAULT '{}',
  PRIMARY KEY (`id`),
  KEY `expectation_id` (`expectation_id`),
  KEY `report_fk_validation_result` (`validation_report_id`),
  CONSTRAINT `report_fk_validation_result` FOREIGN KEY (`validation_report_id`) REFERENCES `validation_report` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `variables`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `variables` (
  `id` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `value` varchar(1024) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `visibility` tinyint NOT NULL DEFAULT '0',
  `hide` tinyint NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping events for database 'hopsworks'
--

--
-- Dumping routines for database 'hopsworks'
--

--
-- Current Database: `dbt2`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `dbt2` /*!40100 DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci */ /*!80016 DEFAULT ENCRYPTION='N' */;

USE `dbt2`;

--
-- Dumping events for database 'dbt2'
--

--
-- Dumping routines for database 'dbt2'
--

--
-- Current Database: `hops`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `hops` /*!40100 DEFAULT CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci */ /*!80016 DEFAULT ENCRYPTION='N' */;

USE `hops`;

--
-- Table structure for table `flyway_schema_history`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `flyway_schema_history` (
  `installed_rank` int NOT NULL,
  `version` varchar(50) DEFAULT NULL,
  `description` varchar(200) NOT NULL,
  `type` varchar(20) NOT NULL,
  `script` varchar(1000) NOT NULL,
  `checksum` int DEFAULT NULL,
  `installed_by` varchar(100) NOT NULL,
  `installed_on` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `execution_time` int NOT NULL,
  `success` tinyint(1) NOT NULL,
  PRIMARY KEY (`installed_rank`),
  KEY `flyway_schema_history_s_idx` (`success`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_aces`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_aces` (
  `inode_id` bigint NOT NULL,
  `index` int NOT NULL,
  `subject` varchar(100) COLLATE latin1_general_cs NOT NULL,
  `type` int NOT NULL DEFAULT '0',
  `is_default` tinyint NOT NULL DEFAULT '0',
  `permission` int NOT NULL DEFAULT '0',
  PRIMARY KEY (`inode_id`,`index`),
  KEY `inode_idx` (`index`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_active_block_reports`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_active_block_reports` (
  `dn_address` varchar(128) NOT NULL,
  `nn_id` bigint DEFAULT NULL,
  `start_time` bigint DEFAULT NULL,
  `num_blocks` bigint DEFAULT NULL,
  `nn_address` varchar(128) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`dn_address`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_block_checksum`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_block_checksum` (
  `inode_id` bigint NOT NULL,
  `block_index` int NOT NULL,
  `checksum` bigint NOT NULL,
  PRIMARY KEY (`inode_id`,`block_index`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_block_infos`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_block_infos` (
  `inode_id` bigint NOT NULL,
  `block_id` bigint NOT NULL,
  `block_index` int DEFAULT NULL,
  `num_bytes` bigint DEFAULT NULL,
  `generation_stamp` bigint DEFAULT NULL,
  `block_under_construction_state` int DEFAULT NULL,
  `time_stamp` bigint DEFAULT NULL,
  `primary_node_index` int DEFAULT NULL,
  `block_recovery_id` bigint DEFAULT NULL,
  `truncate_block_num_bytes` bigint NOT NULL DEFAULT '-1',
  `truncate_block_generation_stamp` bigint NOT NULL DEFAULT '-1',
  `cloud_bucket_id` smallint NOT NULL DEFAULT '-1',
  PRIMARY KEY (`inode_id`,`block_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_block_lookup_table`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_block_lookup_table` (
  `block_id` bigint NOT NULL,
  `inode_id` bigint DEFAULT NULL,
  PRIMARY KEY (`block_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (block_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_cache_directive`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_cache_directive` (
  `id` bigint NOT NULL,
  `replication` smallint NOT NULL,
  `expirytime` bigint NOT NULL,
  `bytes_needed` bigint NOT NULL,
  `bytes_cached` bigint NOT NULL,
  `files_needed` bigint NOT NULL,
  `files_cached` bigint NOT NULL,
  `pool` varchar(250) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `pool` (`pool`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_cache_directive_path`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_cache_directive_path` (
  `id` bigint NOT NULL,
  `index` smallint NOT NULL,
  `value` varchar(2500) NOT NULL,
  PRIMARY KEY (`id`,`index`),
  CONSTRAINT `id` FOREIGN KEY (`id`) REFERENCES `hdfs_cache_directive` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_cache_pool`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_cache_pool` (
  `pool_name` varchar(250) NOT NULL,
  `owner_name` varchar(250) NOT NULL,
  `group_name` varchar(250) NOT NULL,
  `mode` smallint NOT NULL,
  `limit` bigint NOT NULL,
  `max_relative_expiry_ms` bigint NOT NULL,
  `bytes_needed` bigint NOT NULL,
  `bytes_cached` bigint NOT NULL,
  `files_needed` bigint NOT NULL,
  `files_cached` bigint NOT NULL,
  PRIMARY KEY (`pool_name`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_cached_block`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_cached_block` (
  `block_id` bigint NOT NULL,
  `inode_id` bigint NOT NULL,
  `datanode_id` varchar(250) NOT NULL,
  `status` varchar(250) NOT NULL,
  `replication_and_mark` smallint NOT NULL,
  PRIMARY KEY (`block_id`,`inode_id`,`datanode_id`),
  KEY `inode_id` (`inode_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_cloud_buckets`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_cloud_buckets` (
  `id` smallint NOT NULL AUTO_INCREMENT,
  `name` varchar(256) COLLATE utf8mb4_unicode_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=ndbcluster DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_corrupt_replicas`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_corrupt_replicas` (
  `inode_id` bigint NOT NULL,
  `block_id` bigint NOT NULL,
  `storage_id` int NOT NULL,
  `timestamp` bigint NOT NULL,
  `reason` varchar(100) COLLATE latin1_general_cs NOT NULL DEFAULT 'NONE',
  PRIMARY KEY (`inode_id`,`block_id`,`storage_id`),
  KEY `timestamp` (`timestamp`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_directory_with_quota_feature`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_directory_with_quota_feature` (
  `inodeId` bigint NOT NULL,
  `nsquota` bigint DEFAULT NULL,
  `ssquota` bigint DEFAULT NULL,
  `nscount` bigint DEFAULT NULL,
  `storage_space` bigint DEFAULT NULL,
  `typespace_quota_disk` bigint NOT NULL DEFAULT '-1',
  `typespace_quota_ssd` bigint NOT NULL DEFAULT '-1',
  `typespace_quota_raid5` bigint NOT NULL DEFAULT '-1',
  `typespace_quota_archive` bigint NOT NULL DEFAULT '-1',
  `typespace_quota_db` bigint NOT NULL DEFAULT '-1',
  `typespace_used_disk` bigint NOT NULL DEFAULT '-1',
  `typespace_used_ssd` bigint NOT NULL DEFAULT '-1',
  `typespace_used_raid5` bigint NOT NULL DEFAULT '-1',
  `typespace_used_archive` bigint NOT NULL DEFAULT '-1',
  `typespace_used_db` bigint NOT NULL DEFAULT '-1',
  `typespace_quota_cloud` bigint NOT NULL DEFAULT '-1',
  `typespace_used_cloud` bigint NOT NULL DEFAULT '-1',
  `typespace_used_provided` bigint NOT NULL DEFAULT '-1',
  `typespace_quota_provided` bigint NOT NULL DEFAULT '-1',
  PRIMARY KEY (`inodeId`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inodeId) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_encoding_jobs`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_encoding_jobs` (
  `jt_identifier` varchar(50) COLLATE latin1_general_cs NOT NULL,
  `job_id` int NOT NULL,
  `path` varchar(3000) COLLATE latin1_general_cs NOT NULL,
  `job_dir` varchar(200) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`jt_identifier`,`job_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_encoding_status`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_encoding_status` (
  `inode_id` bigint NOT NULL,
  `status` int DEFAULT NULL,
  `codec` varchar(8) COLLATE latin1_general_cs DEFAULT NULL,
  `target_replication` smallint DEFAULT NULL,
  `parity_status` int DEFAULT NULL,
  `status_modification_time` bigint DEFAULT NULL,
  `parity_status_modification_time` bigint DEFAULT NULL,
  `parity_inode_id` bigint DEFAULT NULL,
  `parity_file_name` char(36) COLLATE latin1_general_cs DEFAULT NULL,
  `lost_blocks` int DEFAULT '0',
  `lost_parity_blocks` int DEFAULT '0',
  `revoked` tinyint DEFAULT '0',
  PRIMARY KEY (`inode_id`),
  UNIQUE KEY `parity_inode_id` (`parity_inode_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_encryption_zone`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_encryption_zone` (
  `inode_id` bigint NOT NULL,
  `zone_info` varbinary(13500) DEFAULT NULL,
  PRIMARY KEY (`inode_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_excess_replicas`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_excess_replicas` (
  `inode_id` bigint NOT NULL,
  `block_id` bigint NOT NULL,
  `storage_id` int NOT NULL,
  PRIMARY KEY (`inode_id`,`block_id`,`storage_id`),
  KEY `storage_idx` (`storage_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_groups`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_groups` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(100) COLLATE latin1_general_cs NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=ndbcluster AUTO_INCREMENT=221 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_hash_buckets`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_hash_buckets` (
  `storage_id` int NOT NULL,
  `bucket_id` int NOT NULL,
  `hash` binary(20) NOT NULL DEFAULT '0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',
  PRIMARY KEY (`storage_id`,`bucket_id`),
  KEY `storage_idx` (`storage_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (storage_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_inmemory_file_inode_data`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_inmemory_file_inode_data` (
  `inode_id` bigint NOT NULL,
  `data` varbinary(1024) NOT NULL,
  PRIMARY KEY (`inode_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_inode_dataset_lookup`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_inode_dataset_lookup` (
  `inode_id` bigint NOT NULL,
  `dataset_id` bigint DEFAULT NULL,
  PRIMARY KEY (`inode_id`),
  KEY `dataset_id` (`dataset_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_inodes`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_inodes` (
  `partition_id` bigint NOT NULL,
  `parent_id` bigint NOT NULL,
  `name` varchar(255) COLLATE latin1_general_cs NOT NULL DEFAULT '',
  `id` bigint DEFAULT NULL,
  `user_id` int DEFAULT NULL,
  `group_id` int DEFAULT NULL,
  `modification_time` bigint DEFAULT NULL,
  `access_time` bigint DEFAULT NULL,
  `permission` smallint DEFAULT NULL,
  `client_name` varchar(100) COLLATE latin1_general_cs DEFAULT NULL,
  `client_machine` varchar(100) COLLATE latin1_general_cs DEFAULT NULL,
  `generation_stamp` int DEFAULT NULL,
  `header` bigint DEFAULT NULL,
  `symlink` varchar(255) COLLATE latin1_general_cs DEFAULT NULL,
  `subtree_lock_owner` bigint DEFAULT NULL,
  `size` bigint NOT NULL DEFAULT '0',
  `quota_enabled` tinyint NOT NULL,
  `meta_enabled` tinyint DEFAULT '0',
  `is_dir` tinyint NOT NULL,
  `under_construction` tinyint NOT NULL,
  `subtree_locked` tinyint DEFAULT NULL,
  `file_stored_in_db` tinyint NOT NULL DEFAULT '0',
  `logical_time` int NOT NULL DEFAULT '0',
  `storage_policy` bit(8) NOT NULL DEFAULT b'0',
  `children_num` int NOT NULL DEFAULT '0',
  `num_aces` int NOT NULL DEFAULT '0',
  `num_user_xattrs` tinyint NOT NULL DEFAULT '0',
  `num_sys_xattrs` tinyint NOT NULL DEFAULT '0',
  PRIMARY KEY (`partition_id`,`parent_id`,`name`),
  KEY `pidex` (`parent_id`),
  KEY `inode_idx` (`id`),
  KEY `c1` (`parent_id`,`partition_id`),
  KEY `c2` (`partition_id`,`parent_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (partition_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_invalidated_blocks`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_invalidated_blocks` (
  `inode_id` bigint NOT NULL,
  `block_id` bigint NOT NULL,
  `storage_id` int NOT NULL,
  `generation_stamp` bigint NOT NULL,
  `num_bytes` bigint DEFAULT NULL,
  `cloud_bucket_id` smallint NOT NULL DEFAULT '-1',
  `delete_cloud_copy` tinyint NOT NULL DEFAULT '1',
  PRIMARY KEY (`inode_id`,`block_id`,`generation_stamp`,`storage_id`),
  KEY `storage_idx` (`storage_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_le_descriptors`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_le_descriptors` (
  `id` bigint NOT NULL,
  `counter` bigint NOT NULL,
  `rpc_addresses` varchar(128) COLLATE latin1_general_cs NOT NULL,
  `http_address` varchar(100) COLLATE latin1_general_cs DEFAULT NULL,
  `partition_val` int NOT NULL DEFAULT '0',
  `location_domain_id` tinyint DEFAULT '0',
  PRIMARY KEY (`id`,`partition_val`),
  KEY `part` (`partition_val`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (partition_val) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_lease_creation_locks`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_lease_creation_locks` (
  `id` int NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_lease_paths`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_lease_paths` (
  `holder_id` int NOT NULL,
  `path` varchar(3000) COLLATE latin1_general_cs NOT NULL,
  `last_block_id` bigint DEFAULT '-1',
  `penultimate_block_id` bigint DEFAULT '-1',
  PRIMARY KEY (`holder_id`,`path`),
  KEY `path_idx` (`path`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (holder_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_leases`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_leases` (
  `holder_id` int NOT NULL DEFAULT '0',
  `holder` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `last_update` bigint DEFAULT NULL,
  `count` int NOT NULL DEFAULT '0',
  PRIMARY KEY (`holder_id`,`holder`),
  KEY `update_idx` (`last_update`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (holder_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_metadata_log`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_metadata_log` (
  `dataset_id` bigint NOT NULL,
  `inode_id` bigint NOT NULL,
  `logical_time` int NOT NULL,
  `pk1` bigint DEFAULT NULL,
  `pk2` bigint DEFAULT NULL,
  `pk3` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT '',
  `operation` smallint NOT NULL,
  `inode_partition_id` bigint DEFAULT NULL,
  `inode_parent_id` bigint DEFAULT NULL,
  `inode_name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL DEFAULT '',
  PRIMARY KEY (`dataset_id`,`inode_id`,`logical_time`),
  KEY `logical_time` (`logical_time`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_misreplicated_range_queue`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_misreplicated_range_queue` (
  `nn_id` bigint NOT NULL,
  `start_index` bigint NOT NULL,
  PRIMARY KEY (`nn_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_on_going_sub_tree_ops`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_on_going_sub_tree_ops` (
  `partition_id` int NOT NULL DEFAULT '0',
  `path` varchar(3000) COLLATE latin1_general_cs NOT NULL,
  `namenode_id` bigint NOT NULL,
  `op_name` int NOT NULL,
  `start_time` bigint NOT NULL,
  `async_lock_recovery_time` bigint NOT NULL DEFAULT '0',
  `user` varchar(256) COLLATE latin1_general_cs NOT NULL DEFAULT '',
  `inode_id` bigint NOT NULL DEFAULT '0',
  PRIMARY KEY (`partition_id`,`path`),
  KEY `partindex` (`partition_id`),
  KEY `nameidx` (`path`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (partition_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_ondisk_large_file_inode_data`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_ondisk_large_file_inode_data` (
  `inode_id` bigint NOT NULL,
  `dindex` int NOT NULL,
  `data` varbinary(8000) NOT NULL,
  PRIMARY KEY (`inode_id`,`dindex`)
) /*!50100 TABLESPACE `ts_1` STORAGE DISK */ ENGINE=ndbcluster DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_ondisk_medium_file_inode_data`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_ondisk_medium_file_inode_data` (
  `inode_id` bigint NOT NULL,
  `data` varbinary(4000) NOT NULL,
  PRIMARY KEY (`inode_id`)
) /*!50100 TABLESPACE `ts_1` STORAGE DISK */ ENGINE=ndbcluster DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_ondisk_small_file_inode_data`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_ondisk_small_file_inode_data` (
  `inode_id` bigint NOT NULL,
  `data` varbinary(2000) NOT NULL,
  PRIMARY KEY (`inode_id`)
) /*!50100 TABLESPACE `ts_1` STORAGE DISK */ ENGINE=ndbcluster DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_path_memcached`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_path_memcached` (
  `path` varchar(128) COLLATE latin1_general_cs NOT NULL,
  `inodeids` varbinary(13500) NOT NULL,
  PRIMARY KEY (`path`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_pending_blocks`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_pending_blocks` (
  `inode_id` bigint NOT NULL,
  `block_id` bigint NOT NULL,
  `time_stamp` bigint NOT NULL,
  `target` varchar(255) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`inode_id`,`block_id`,`target`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_provided_block_cached_location`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_provided_block_cached_location` (
  `block_id` bigint NOT NULL,
  `storage_id` int DEFAULT NULL,
  PRIMARY KEY (`block_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_provided_block_report_tasks`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_provided_block_report_tasks` (
  `id` bigint NOT NULL AUTO_INCREMENT,
  `start_index` bigint NOT NULL,
  `end_index` bigint NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_unicode_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_quota_update`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_quota_update` (
  `id` int NOT NULL,
  `inode_id` bigint NOT NULL,
  `namespace_delta` bigint DEFAULT NULL,
  `storage_space_delta` bigint DEFAULT NULL,
  `typespace_delta_disk` bigint NOT NULL DEFAULT '-1',
  `typespace_delta_ssd` bigint NOT NULL DEFAULT '-1',
  `typespace_delta_raid5` bigint NOT NULL DEFAULT '-1',
  `typespace_delta_archive` bigint NOT NULL DEFAULT '-1',
  `typespace_delta_db` bigint NOT NULL DEFAULT '-1',
  `typespace_delta_cloud` bigint NOT NULL DEFAULT '-1',
  `typespace_delta_provided` bigint NOT NULL DEFAULT '-1',
  PRIMARY KEY (`inode_id`,`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_repair_jobs`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_repair_jobs` (
  `jt_identifier` varchar(50) COLLATE latin1_general_cs NOT NULL,
  `job_id` int NOT NULL,
  `path` varchar(3000) COLLATE latin1_general_cs NOT NULL,
  `in_dir` varchar(3000) COLLATE latin1_general_cs NOT NULL,
  `out_dir` varchar(3000) COLLATE latin1_general_cs NOT NULL,
  PRIMARY KEY (`jt_identifier`,`job_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_replica_under_constructions`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_replica_under_constructions` (
  `inode_id` bigint NOT NULL,
  `block_id` bigint NOT NULL,
  `storage_id` int NOT NULL,
  `state` int DEFAULT NULL,
  `bucket_id` int NOT NULL,
  `chosen_as_primary` tinyint NOT NULL DEFAULT '0',
  `generation_stamp` bigint NOT NULL DEFAULT '0',
  PRIMARY KEY (`inode_id`,`block_id`,`storage_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_replicas`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_replicas` (
  `inode_id` bigint NOT NULL,
  `block_id` bigint NOT NULL,
  `storage_id` int NOT NULL,
  `bucket_id` int NOT NULL,
  PRIMARY KEY (`inode_id`,`block_id`,`storage_id`),
  KEY `storage_idx` (`storage_id`),
  KEY `hash_bucket_idx` (`bucket_id`),
  KEY `storage_and_bucket_idx` (`storage_id`,`bucket_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_retry_cache_entry`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_retry_cache_entry` (
  `client_id` varbinary(16) NOT NULL,
  `call_id` int NOT NULL,
  `payload` varbinary(13500) DEFAULT NULL,
  `expiration_time` bigint DEFAULT NULL,
  `state` bit(8) DEFAULT NULL,
  `epoch` bigint NOT NULL DEFAULT '0',
  PRIMARY KEY (`client_id`,`call_id`,`epoch`),
  KEY `expiration_time` (`expiration_time`),
  KEY `epoch_idx` (`epoch`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1
/*!50100 PARTITION BY KEY (epoch) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_safe_blocks`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_safe_blocks` (
  `id` bigint NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_storage_id_map`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_storage_id_map` (
  `storage_id` varchar(128) COLLATE latin1_general_cs NOT NULL,
  `sid` int NOT NULL,
  PRIMARY KEY (`storage_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_storages`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_storages` (
  `host_id` varchar(255) NOT NULL,
  `storage_id` int NOT NULL,
  `storage_type` int NOT NULL,
  `state` varchar(100) NOT NULL DEFAULT 'NORMAL',
  PRIMARY KEY (`storage_id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_under_replicated_blocks`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_under_replicated_blocks` (
  `inode_id` bigint NOT NULL,
  `block_id` bigint NOT NULL,
  `level` int DEFAULT NULL,
  `timestamp` bigint NOT NULL,
  `expected_replicas` int NOT NULL DEFAULT '3',
  PRIMARY KEY (`inode_id`,`block_id`),
  KEY `level` (`level`,`timestamp`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_users`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_users` (
  `id` int NOT NULL AUTO_INCREMENT,
  `name` varchar(100) COLLATE latin1_general_cs NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`)
) ENGINE=ndbcluster AUTO_INCREMENT=23 DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_users_groups`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_users_groups` (
  `user_id` int NOT NULL,
  `group_id` int NOT NULL,
  PRIMARY KEY (`user_id`,`group_id`),
  KEY `group_id` (`group_id`),
  CONSTRAINT `group_id` FOREIGN KEY (`group_id`) REFERENCES `hdfs_groups` (`id`) ON DELETE CASCADE,
  CONSTRAINT `user_id` FOREIGN KEY (`user_id`) REFERENCES `hdfs_users` (`id`) ON DELETE CASCADE
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (user_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_variables`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_variables` (
  `id` int NOT NULL,
  `value` varbinary(500) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `hdfs_xattrs`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `hdfs_xattrs` (
  `inode_id` bigint NOT NULL,
  `namespace` tinyint NOT NULL,
  `name` varchar(255) CHARACTER SET latin1 COLLATE latin1_general_cs NOT NULL,
  `value` varbinary(13500) DEFAULT '',
  `num_parts` smallint NOT NULL DEFAULT '1',
  `index` smallint NOT NULL DEFAULT '0',
  PRIMARY KEY (`inode_id`,`namespace`,`name`,`index`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs COMMENT='NDB_TABLE=READ_BACKUP=1'
/*!50100 PARTITION BY KEY (inode_id) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_applicationattemptstate`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_applicationattemptstate` (
  `applicationid` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `applicationattemptid` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `applicationattemptstate` longblob,
  `applicationattempttrakingurl` varchar(300) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`applicationid`,`applicationattemptid`),
  KEY `applicationid` (`applicationid`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (applicationid) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_applicationstate`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_applicationstate` (
  `applicationid` varchar(45) COLLATE latin1_general_cs NOT NULL,
  `appstate` longblob,
  `appuser` varchar(100) COLLATE latin1_general_cs DEFAULT NULL,
  `appname` varchar(200) COLLATE latin1_general_cs DEFAULT NULL,
  `appsmstate` varchar(45) COLLATE latin1_general_cs DEFAULT NULL,
  PRIMARY KEY (`applicationid`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (applicationid) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_conf`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_conf` (
  `index` int NOT NULL,
  `conf` blob NOT NULL,
  PRIMARY KEY (`index`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_conf_mutation`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_conf_mutation` (
  `index` int NOT NULL,
  `mutation` varbinary(13000) NOT NULL,
  PRIMARY KEY (`index`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_delegation_key`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_delegation_key` (
  `key` int NOT NULL,
  `delegationkey` varbinary(13500) DEFAULT NULL,
  PRIMARY KEY (`key`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_delegation_token`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_delegation_token` (
  `seq_number` int NOT NULL,
  `rmdt_identifier` varbinary(13500) DEFAULT NULL,
  PRIMARY KEY (`seq_number`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_le_descriptors`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_le_descriptors` (
  `id` bigint NOT NULL,
  `counter` bigint NOT NULL,
  `rpc_addresses` varchar(128) COLLATE latin1_general_cs NOT NULL,
  `http_address` varchar(100) COLLATE latin1_general_cs DEFAULT NULL,
  `partition_val` int NOT NULL DEFAULT '0',
  `location_domain_id` tinyint DEFAULT '0',
  PRIMARY KEY (`id`,`partition_val`),
  KEY `part` (`partition_val`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (partition_val) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_price_multiplicator`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_price_multiplicator` (
  `id` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `multiplicator` float NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_projects_daily_cost`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_projects_daily_cost` (
  `user` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `projectname` varchar(100) COLLATE latin1_general_cs NOT NULL,
  `day` bigint NOT NULL,
  `credits_used` float DEFAULT NULL,
  `app_ids` varchar(3000) COLLATE latin1_general_cs NOT NULL DEFAULT '',
  PRIMARY KEY (`projectname`,`day`,`user`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (`user`) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_projects_quota`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_projects_quota` (
  `projectname` varchar(100) COLLATE latin1_general_cs NOT NULL,
  `total` float DEFAULT '0',
  `quota_remaining` float DEFAULT '0',
  PRIMARY KEY (`projectname`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (projectname) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `yarn_reservation_state`
--

/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE IF NOT EXISTS `yarn_reservation_state` (
  `plan_name` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `reservation_id_name` varchar(255) COLLATE latin1_general_cs NOT NULL,
  `state` varbinary(13000) NOT NULL,
  PRIMARY KEY (`plan_name`,`reservation_id_name`)
) ENGINE=ndbcluster DEFAULT CHARSET=latin1 COLLATE=latin1_general_cs
/*!50100 PARTITION BY KEY (reservation_id_name) */;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping events for database 'hops'
--

--
-- Dumping routines for database 'hops'
--
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb4 */ ;
/*!50003 SET character_set_results = utf8mb4 */ ;
/*!50003 SET collation_connection  = utf8mb4_0900_ai_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = 'ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION' */ ;
DELIMITER ;;
CREATE DEFINER=`hopsworksroot`@`%` PROCEDURE `flyway`()
BEGIN
	IF EXISTS(SELECT table_name
            FROM INFORMATION_SCHEMA.TABLES
			WHERE table_schema = 'hops'
             AND table_name LIKE 'flyway_schema_history')

	THEN
		ALTER TABLE `flyway_schema_history` engine = 'ndb';
	END IF;
END ;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!50003 SET @saved_cs_client      = @@character_set_client */ ;
/*!50003 SET @saved_cs_results     = @@character_set_results */ ;
/*!50003 SET @saved_col_connection = @@collation_connection */ ;
/*!50003 SET character_set_client  = utf8mb4 */ ;
/*!50003 SET character_set_results = utf8mb4 */ ;
/*!50003 SET collation_connection  = utf8mb4_0900_ai_ci */ ;
/*!50003 SET @saved_sql_mode       = @@sql_mode */ ;
/*!50003 SET sql_mode              = 'ONLY_FULL_GROUP_BY,STRICT_TRANS_TABLES,NO_ZERO_IN_DATE,NO_ZERO_DATE,ERROR_FOR_DIVISION_BY_ZERO,NO_ENGINE_SUBSTITUTION' */ ;
DELIMITER ;;
CREATE DEFINER=`hopsworksroot`@`%` PROCEDURE `simpleproc`()
BEGIN
	DECLARE lc INTEGER;
	DECLARE tc INTEGER;

	SELECT count(LOGFILE_GROUP_NAME) INTO lc FROM INFORMATION_SCHEMA.FILES where LOGFILE_GROUP_NAME="lg_1";
	IF (lc = 0) THEN
	    CREATE LOGFILE GROUP lg_1 ADD UNDOFILE 'undo_log_0.log' INITIAL_SIZE = 128M ENGINE ndbcluster;
	ELSE
		select "The LogFile has already been created" as "";
	END IF;


	SELECT count(TABLESPACE_NAME) INTO tc FROM INFORMATION_SCHEMA.FILES where TABLESPACE_NAME="ts_1";
	IF (tc = 0) THEN
		CREATE TABLESPACE ts_1 ADD datafile 'ts_1_data_file_0.dat' use LOGFILE GROUP lg_1 INITIAL_SIZE = 128M  ENGINE ndbcluster;
	ELSE
		select "The DataFile has already been created" as "";
	END IF;
END ;;
DELIMITER ;
/*!50003 SET sql_mode              = @saved_sql_mode */ ;
/*!50003 SET character_set_client  = @saved_cs_client */ ;
/*!50003 SET character_set_results = @saved_cs_results */ ;
/*!50003 SET collation_connection  = @saved_col_connection */ ;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2025-05-28 13:17:33
